package com.skplanet.pdp.sentinel.shuttle;

import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONArray;

import java.lang.reflect.Field;

import java.util.Collection;
import java.util.List;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;




/*
 * Sentinel Shuttle
 *
 * Template version
 *  - 0.1.0 (2014.04.22) : support auto encryption
 *  - 0.1.1 (2014.05.28) : sentinel_meta
 *  - 0.1.2 (2014.07.17) : \r escaping
 *  - 0.1.3 (2014.11.11) : remove _$ssToken
 *  - 0.1.4 (2014.11.21) : toJsonObject(jsonObject)
 *
 * Author
 *  - Sentinel Shuttle Generator v1.5
 *  - junghyun@sk.com (Data Infrastructure)
 */
public class ElevenstAppClientSentinelShuttle {


    private static final String _$ssTemplateVersion = "0.1.3";
    private static final String _$ssVersion = "16.06.03:1.6.4:11";
    private static final String _$ssSchemaId = "58184fdf140000b3ade1d75b";
    private static final String _$ssDelim = "\t";
    private static final ArrayList<String> _$actionKey = new ArrayList() {{add("event_id");}};
    private static final String _$logVersionKey = "log_version";
    private static final String _$projectId = "projectId";

    


    /**
     * Fields
     */
    private static final ArrayList<String> headerFieldNameList = new ArrayList<String>(){{
		add("base_time");
		add("local_time");
		add("recv_time");
		add("os_name");
		add("os_version");
		add("resolution");
		add("screen_width");
		add("screen_height");
		add("language_code");
		add("rake_lib");
		add("rake_lib_version");
		add("ip");
		add("recv_host");
		add("token");
		add("log_version");
		add("device_id");
		add("device_model");
		add("manufacturer");
		add("carrier_name");
		add("network_type");
		add("app_version");
		add("browser_name");
		add("browser_version");
		add("referrer");
		add("url");
		add("document_title");
		add("log_source");
		add("session_id");
		add("event_id");
		add("page_id");
		add("action_id");
		add("mdn");
		add("mem_no");
		add("poc");
		add("pcid");
		add("tracking_id");
		add("reserved1");
		add("reserved2");
		add("reserved3");
		add("reserved4");
		add("reserved5");

    }};

    private static final ArrayList<String> bodyFieldNameList = new ArrayList<String>(){{
		add("disp_spce_id");
		add("display_order");
		add("source_page_id");
		add("prd_no");
		add("prd_img_url");
		add("prd_no_list");
		add("tracking_id_list");
		add("disp_ctgr_no1");
		add("disp_ctgr_no2");
		add("disp_ctgr_no3");
		add("keyword");
		add("sub_keywords");
		add("catalog_no");
		add("rel_prd_no");
		add("rel_prd_img_url");
		add("rel_tracking_id");
		add("rel_display_order");
		add("rel_prd_no_list");
		add("rel_tracking_id_list");
		add("eval_score");
		add("eval_type");
		add("disp_ctgr_no_list");
		add("link_url");
		add("link_url_list");

    }};

    private static final ArrayList<String> encryptedFieldsList = new ArrayList<String>(){{
		add("device_id");
		add("mdn");
		add("mem_no");

    }};

    private String base_time = null;
    private String local_time = null;
    private String recv_time = null;
    private String os_name = null;
    private String os_version = null;
    private String resolution = null;
    private Long screen_width = null;
    private Long screen_height = null;
    private String language_code = null;
    private String rake_lib = null;
    private String rake_lib_version = null;
    private String ip = null;
    private String recv_host = null;
    private String token = null;
    private String log_version = _$ssVersion;
    private String device_id = null;
    private String device_model = null;
    private String manufacturer = null;
    private String carrier_name = null;
    private String network_type = null;
    private String app_version = null;
    private String browser_name = null;
    private String browser_version = null;
    private String referrer = null;
    private String url = null;
    private String document_title = null;
    private String log_source = null;
    private String session_id = null;
    private String event_id = null;
    private String page_id = null;
    private String action_id = null;
    private String mdn = null;
    private String mem_no = null;
    private String poc = null;
    private String pcid = null;
    private String tracking_id = null;
    private String reserved1 = null;
    private String reserved2 = null;
    private String reserved3 = null;
    private String reserved4 = null;
    private String reserved5 = null;
    private String disp_spce_id = null;
    private Long display_order = null;
    private String source_page_id = null;
    private String prd_no = null;
    private String prd_img_url = null;
    private List<String> prd_no_list = new ArrayList<String>();
    private List<String> tracking_id_list = new ArrayList<String>();
    private String disp_ctgr_no1 = null;
    private String disp_ctgr_no2 = null;
    private String disp_ctgr_no3 = null;
    private String keyword = null;
    private List<String> sub_keywords = new ArrayList<String>();
    private String catalog_no = null;
    private String rel_prd_no = null;
    private String rel_prd_img_url = null;
    private String rel_tracking_id = null;
    private Long rel_display_order = null;
    private List<String> rel_prd_no_list = new ArrayList<String>();
    private List<String> rel_tracking_id_list = new ArrayList<String>();
    private String eval_score = null;
    private String eval_type = null;
    private List<String> disp_ctgr_no_list = new ArrayList<String>();
    private String link_url = null;
    private List<String> link_url_list = new ArrayList<String>();



    /**
     * Methods
     */
 
    /*
     * Set base_time
     */
    public ElevenstAppClientSentinelShuttle base_time(String base_time){
        this.base_time = base_time;
        return this;
    }


    /*
     * Set local_time
     */
    public ElevenstAppClientSentinelShuttle local_time(String local_time){
        this.local_time = local_time;
        return this;
    }


    /*
     * Set recv_time
     */
    public ElevenstAppClientSentinelShuttle recv_time(String recv_time){
        this.recv_time = recv_time;
        return this;
    }


    /*
     * Set os_name
     */
    public ElevenstAppClientSentinelShuttle os_name(String os_name){
        this.os_name = os_name;
        return this;
    }


    /*
     * Set os_version
     */
    public ElevenstAppClientSentinelShuttle os_version(String os_version){
        this.os_version = os_version;
        return this;
    }


    /*
     * Set resolution
     */
    public ElevenstAppClientSentinelShuttle resolution(String resolution){
        this.resolution = resolution;
        return this;
    }


    /*
     * Set screen_width
     */
    public ElevenstAppClientSentinelShuttle screen_width(Long screen_width){
        this.screen_width = screen_width;
        return this;
    }


    /*
     * Set screen_height
     */
    public ElevenstAppClientSentinelShuttle screen_height(Long screen_height){
        this.screen_height = screen_height;
        return this;
    }


    /*
     * Set language_code
     */
    public ElevenstAppClientSentinelShuttle language_code(String language_code){
        this.language_code = language_code;
        return this;
    }


    /*
     * Set rake_lib
     */
    public ElevenstAppClientSentinelShuttle rake_lib(String rake_lib){
        this.rake_lib = rake_lib;
        return this;
    }


    /*
     * Set rake_lib_version
     */
    public ElevenstAppClientSentinelShuttle rake_lib_version(String rake_lib_version){
        this.rake_lib_version = rake_lib_version;
        return this;
    }


    /*
     * Set ip
     */
    public ElevenstAppClientSentinelShuttle ip(String ip){
        this.ip = ip;
        return this;
    }


    /*
     * Set recv_host
     */
    public ElevenstAppClientSentinelShuttle recv_host(String recv_host){
        this.recv_host = recv_host;
        return this;
    }


    /*
     * Set token
     */
    public ElevenstAppClientSentinelShuttle token(String token){
        this.token = token;
        return this;
    }


    /*
     * Set log_version
     */
    private ElevenstAppClientSentinelShuttle log_version(String log_version){
        this.log_version = log_version;
        return this;
    }


    /*
     * Set device_id
     */
    public ElevenstAppClientSentinelShuttle device_id(String device_id){
        this.device_id = device_id;
        return this;
    }


    /*
     * Set device_model
     */
    public ElevenstAppClientSentinelShuttle device_model(String device_model){
        this.device_model = device_model;
        return this;
    }


    /*
     * Set manufacturer
     */
    public ElevenstAppClientSentinelShuttle manufacturer(String manufacturer){
        this.manufacturer = manufacturer;
        return this;
    }


    /*
     * Set carrier_name
     */
    public ElevenstAppClientSentinelShuttle carrier_name(String carrier_name){
        this.carrier_name = carrier_name;
        return this;
    }


    /*
     * Set network_type
     */
    public ElevenstAppClientSentinelShuttle network_type(String network_type){
        this.network_type = network_type;
        return this;
    }


    /*
     * Set app_version
     */
    public ElevenstAppClientSentinelShuttle app_version(String app_version){
        this.app_version = app_version;
        return this;
    }


    /*
     * Set browser_name
     */
    public ElevenstAppClientSentinelShuttle browser_name(String browser_name){
        this.browser_name = browser_name;
        return this;
    }


    /*
     * Set browser_version
     */
    public ElevenstAppClientSentinelShuttle browser_version(String browser_version){
        this.browser_version = browser_version;
        return this;
    }


    /*
     * Set referrer
     */
    public ElevenstAppClientSentinelShuttle referrer(String referrer){
        this.referrer = referrer;
        return this;
    }


    /*
     * Set url
     */
    public ElevenstAppClientSentinelShuttle url(String url){
        this.url = url;
        return this;
    }


    /*
     * Set document_title
     */
    public ElevenstAppClientSentinelShuttle document_title(String document_title){
        this.document_title = document_title;
        return this;
    }


    /*
     * Set log_source
     */
    public ElevenstAppClientSentinelShuttle log_source(String log_source){
        this.log_source = log_source;
        return this;
    }


    /*
     * Set session_id
     */
    public ElevenstAppClientSentinelShuttle session_id(String session_id){
        this.session_id = session_id;
        return this;
    }


    /*
     * Set event_id
     */
    public ElevenstAppClientSentinelShuttle event_id(String event_id){
        this.event_id = event_id;
        return this;
    }


    /*
     * Set page_id
     */
    public ElevenstAppClientSentinelShuttle page_id(String page_id){
        this.page_id = page_id;
        return this;
    }


    /*
     * Set action_id
     */
    public ElevenstAppClientSentinelShuttle action_id(String action_id){
        this.action_id = action_id;
        return this;
    }


    /*
     * Set mdn
     */
    public ElevenstAppClientSentinelShuttle mdn(String mdn){
        this.mdn = mdn;
        return this;
    }


    /*
     * Set mem_no
     */
    public ElevenstAppClientSentinelShuttle mem_no(String mem_no){
        this.mem_no = mem_no;
        return this;
    }


    /*
     * Set poc
     */
    public ElevenstAppClientSentinelShuttle poc(String poc){
        this.poc = poc;
        return this;
    }


    /*
     * Set pcid
     */
    public ElevenstAppClientSentinelShuttle pcid(String pcid){
        this.pcid = pcid;
        return this;
    }


    /*
     * Set tracking_id
     */
    public ElevenstAppClientSentinelShuttle tracking_id(String tracking_id){
        this.tracking_id = tracking_id;
        return this;
    }


    /*
     * Set reserved1
     */
    public ElevenstAppClientSentinelShuttle reserved1(String reserved1){
        this.reserved1 = reserved1;
        return this;
    }


    /*
     * Set reserved2
     */
    public ElevenstAppClientSentinelShuttle reserved2(String reserved2){
        this.reserved2 = reserved2;
        return this;
    }


    /*
     * Set reserved3
     */
    public ElevenstAppClientSentinelShuttle reserved3(String reserved3){
        this.reserved3 = reserved3;
        return this;
    }


    /*
     * Set reserved4
     */
    public ElevenstAppClientSentinelShuttle reserved4(String reserved4){
        this.reserved4 = reserved4;
        return this;
    }


    /*
     * Set reserved5
     */
    public ElevenstAppClientSentinelShuttle reserved5(String reserved5){
        this.reserved5 = reserved5;
        return this;
    }


    /*
     * Set disp_spce_id
     */
    public ElevenstAppClientSentinelShuttle disp_spce_id(String disp_spce_id){
        this.disp_spce_id = disp_spce_id;
        return this;
    }


    /*
     * Set display_order
     */
    public ElevenstAppClientSentinelShuttle display_order(Long display_order){
        this.display_order = display_order;
        return this;
    }


    /*
     * Set source_page_id
     */
    public ElevenstAppClientSentinelShuttle source_page_id(String source_page_id){
        this.source_page_id = source_page_id;
        return this;
    }


    /*
     * Set prd_no
     */
    public ElevenstAppClientSentinelShuttle prd_no(String prd_no){
        this.prd_no = prd_no;
        return this;
    }


    /*
     * Set prd_img_url
     */
    public ElevenstAppClientSentinelShuttle prd_img_url(String prd_img_url){
        this.prd_img_url = prd_img_url;
        return this;
    }


    /*
     * Set prd_no_list
     */
    public ElevenstAppClientSentinelShuttle prd_no_list(List<String> prd_no_list){
        this.prd_no_list = prd_no_list;
        return this;
    }


    /*
     * Set tracking_id_list
     */
    public ElevenstAppClientSentinelShuttle tracking_id_list(List<String> tracking_id_list){
        this.tracking_id_list = tracking_id_list;
        return this;
    }


    /*
     * Set disp_ctgr_no1
     */
    public ElevenstAppClientSentinelShuttle disp_ctgr_no1(String disp_ctgr_no1){
        this.disp_ctgr_no1 = disp_ctgr_no1;
        return this;
    }


    /*
     * Set disp_ctgr_no2
     */
    public ElevenstAppClientSentinelShuttle disp_ctgr_no2(String disp_ctgr_no2){
        this.disp_ctgr_no2 = disp_ctgr_no2;
        return this;
    }


    /*
     * Set disp_ctgr_no3
     */
    public ElevenstAppClientSentinelShuttle disp_ctgr_no3(String disp_ctgr_no3){
        this.disp_ctgr_no3 = disp_ctgr_no3;
        return this;
    }


    /*
     * Set keyword
     */
    public ElevenstAppClientSentinelShuttle keyword(String keyword){
        this.keyword = keyword;
        return this;
    }


    /*
     * Set sub_keywords
     */
    public ElevenstAppClientSentinelShuttle sub_keywords(List<String> sub_keywords){
        this.sub_keywords = sub_keywords;
        return this;
    }


    /*
     * Set catalog_no
     */
    public ElevenstAppClientSentinelShuttle catalog_no(String catalog_no){
        this.catalog_no = catalog_no;
        return this;
    }


    /*
     * Set rel_prd_no
     */
    public ElevenstAppClientSentinelShuttle rel_prd_no(String rel_prd_no){
        this.rel_prd_no = rel_prd_no;
        return this;
    }


    /*
     * Set rel_prd_img_url
     */
    public ElevenstAppClientSentinelShuttle rel_prd_img_url(String rel_prd_img_url){
        this.rel_prd_img_url = rel_prd_img_url;
        return this;
    }


    /*
     * Set rel_tracking_id
     */
    public ElevenstAppClientSentinelShuttle rel_tracking_id(String rel_tracking_id){
        this.rel_tracking_id = rel_tracking_id;
        return this;
    }


    /*
     * Set rel_display_order
     */
    public ElevenstAppClientSentinelShuttle rel_display_order(Long rel_display_order){
        this.rel_display_order = rel_display_order;
        return this;
    }


    /*
     * Set rel_prd_no_list
     */
    public ElevenstAppClientSentinelShuttle rel_prd_no_list(List<String> rel_prd_no_list){
        this.rel_prd_no_list = rel_prd_no_list;
        return this;
    }


    /*
     * Set rel_tracking_id_list
     */
    public ElevenstAppClientSentinelShuttle rel_tracking_id_list(List<String> rel_tracking_id_list){
        this.rel_tracking_id_list = rel_tracking_id_list;
        return this;
    }


    /*
     * Set eval_score
     */
    public ElevenstAppClientSentinelShuttle eval_score(String eval_score){
        this.eval_score = eval_score;
        return this;
    }


    /*
     * Set eval_type
     */
    public ElevenstAppClientSentinelShuttle eval_type(String eval_type){
        this.eval_type = eval_type;
        return this;
    }


    /*
     * Set disp_ctgr_no_list
     */
    public ElevenstAppClientSentinelShuttle disp_ctgr_no_list(List<String> disp_ctgr_no_list){
        this.disp_ctgr_no_list = disp_ctgr_no_list;
        return this;
    }


    /*
     * Set link_url
     */
    public ElevenstAppClientSentinelShuttle link_url(String link_url){
        this.link_url = link_url;
        return this;
    }


    /*
     * Set link_url_list
     */
    public ElevenstAppClientSentinelShuttle link_url_list(List<String> link_url_list){
        this.link_url_list = link_url_list;
        return this;
    }



	public ElevenstAppClientSentinelShuttle setBodyOfDEFAULT(){
		clearBody();
		this.event_id = "DEFAULT";
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfPRODUCT(String disp_spce_id, String prd_no, Long display_order, String disp_ctgr_no1, String disp_ctgr_no2, String disp_ctgr_no3){
		clearBody();
		this.event_id = "PRODUCT";
		this.disp_spce_id = disp_spce_id;
		this.prd_no = prd_no;
		this.display_order = display_order;
		this.disp_ctgr_no1 = disp_ctgr_no1;
		this.disp_ctgr_no2 = disp_ctgr_no2;
		this.disp_ctgr_no3 = disp_ctgr_no3;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfPRODUCTLIST(String disp_spce_id, List<String> prd_no_list, List<String> tracking_id_list){
		clearBody();
		this.event_id = "PRODUCTLIST";
		this.disp_spce_id = disp_spce_id;
		this.prd_no_list = prd_no_list;
		this.tracking_id_list = tracking_id_list;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfKEYWORD(String keyword, List<String> sub_keywords, List<String> prd_no_list){
		clearBody();
		this.event_id = "KEYWORD";
		this.keyword = keyword;
		this.sub_keywords = sub_keywords;
		this.prd_no_list = prd_no_list;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfPAIRPRODUCT(String disp_spce_id, String prd_no, Long display_order, String rel_prd_no, String rel_tracking_id, Long rel_display_order){
		clearBody();
		this.event_id = "PAIRPRODUCT";
		this.disp_spce_id = disp_spce_id;
		this.prd_no = prd_no;
		this.display_order = display_order;
		this.rel_prd_no = rel_prd_no;
		this.rel_tracking_id = rel_tracking_id;
		this.rel_display_order = rel_display_order;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfPAIRPRODUCTLIST(String disp_spce_id, String prd_no, Long display_order, List<String> rel_prd_no_list, List<String> rel_tracking_id_list){
		clearBody();
		this.event_id = "PAIRPRODUCTLIST";
		this.disp_spce_id = disp_spce_id;
		this.prd_no = prd_no;
		this.display_order = display_order;
		this.rel_prd_no_list = rel_prd_no_list;
		this.rel_tracking_id_list = rel_tracking_id_list;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfCATALOG(String disp_spce_id, String catalog_no, Long display_order, List<String> prd_no_list, List<String> tracking_id_list){
		clearBody();
		this.event_id = "CATALOG";
		this.disp_spce_id = disp_spce_id;
		this.catalog_no = catalog_no;
		this.display_order = display_order;
		this.prd_no_list = prd_no_list;
		this.tracking_id_list = tracking_id_list;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfISCHEVAL(String prd_no, String prd_img_url, String eval_score, String eval_type){
		clearBody();
		this.event_id = "ISCHEVAL";
		this.prd_no = prd_no;
		this.prd_img_url = prd_img_url;
		this.eval_score = eval_score;
		this.eval_type = eval_type;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfISCHPRODUCT(String prd_no, String prd_img_url, String rel_prd_no, String rel_prd_img_url, Long display_order){
		clearBody();
		this.event_id = "ISCHPRODUCT";
		this.prd_no = prd_no;
		this.prd_img_url = prd_img_url;
		this.rel_prd_no = rel_prd_no;
		this.rel_prd_img_url = rel_prd_img_url;
		this.display_order = display_order;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfCTGR(String disp_spce_id, Long display_order, String disp_ctgr_no1, String disp_ctgr_no2, String disp_ctgr_no3){
		clearBody();
		this.event_id = "CTGR";
		this.disp_spce_id = disp_spce_id;
		this.display_order = display_order;
		this.disp_ctgr_no1 = disp_ctgr_no1;
		this.disp_ctgr_no2 = disp_ctgr_no2;
		this.disp_ctgr_no3 = disp_ctgr_no3;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfCTGRLIST(String disp_spce_id, List<String> disp_ctgr_no_list){
		clearBody();
		this.event_id = "CTGRLIST";
		this.disp_spce_id = disp_spce_id;
		this.disp_ctgr_no_list = disp_ctgr_no_list;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfLINK(String disp_spce_id, Long display_order, String link_url){
		clearBody();
		this.event_id = "LINK";
		this.disp_spce_id = disp_spce_id;
		this.display_order = display_order;
		this.link_url = link_url;
		return this;
	}

	public ElevenstAppClientSentinelShuttle setBodyOfLINKLIST(String disp_spce_id, List<String> link_url_list){
		clearBody();
		this.event_id = "LINKLIST";
		this.disp_spce_id = disp_spce_id;
		this.link_url_list = link_url_list;
		return this;
	}



    /**
     * Layout Rules
     */
    private static final LinkedHashMap<String, ArrayList<String>> bodyRule = new LinkedHashMap<String, ArrayList<String>>(){{
    }};


    /**
     * Util Functions
     */
    private ArrayList<Field> privateHeaderMemeberList = new ArrayList<Field>();
    private ArrayList<Field> privatebodyMemeberList = new ArrayList<Field>();

    public ElevenstAppClientSentinelShuttle() {

        Class klass = this.getClass();

        for(String name : headerFieldNameList){
            try {
                privateHeaderMemeberList.add(klass.getDeclaredField(name));
            } catch (NoSuchFieldException e) {
                e.printStackTrace();
            }
        }

        for(String name : bodyFieldNameList){
            try {
                privatebodyMemeberList.add(klass.getDeclaredField(name));
            } catch (NoSuchFieldException e) {
                e.printStackTrace();
            }
        }

        // init encrypt module
        initCryptoOnce();
    }

    @Override
    public String toString() {
        return toHBString();
    }

    public String toHBString() {
        return toHBString(this._$ssDelim);
    }

    public String toHBString(String delim) {
        return headerToString(delim) + bodyToString();
    }

    public String headerToString(String delim) {
        StringBuilder headerBuilder = new StringBuilder();

        for (Field member : privateHeaderMemeberList) {
            try {
                member.setAccessible(true);
                Object value = member.get(this);

                if(value == null){
                    headerBuilder.append("");
                }else{
                    String fieldValue = String.valueOf(value);
                    if(encryptedFieldsList.contains(member.getName())){
                        fieldValue = getEncryptedValue(fieldValue);
                    }else{
                        fieldValue = getEscapedValue(fieldValue);
                    }
                    headerBuilder.append(fieldValue);
                }

                headerBuilder.append(delim);


                member.setAccessible(false);

            } catch (IllegalAccessException e) {
                e.printStackTrace();
            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e){
                e.printStackTrace();
            }
        }

        return headerBuilder.toString();
    }


    public void clearBody(){
        for(Field bodyField:privatebodyMemeberList){
            bodyField.setAccessible(true);
            Object value = null;
            try {
                bodyField.set(this, null);
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            }


            bodyField.setAccessible(false);
        }
    }


    public JSONObject getBody() {

            if (bodyFieldNameList.size() == 0) {
                return new JSONObject();
            }

            LinkedHashMap<String, Object> body = new LinkedHashMap<String, Object>();

            Class klass = this.getClass();

            try {
                String actionKeyString = "";
                for (String actionKeyName : this._$actionKey) {
                    Field actionKeyField = klass.getDeclaredField(actionKeyName);
                    actionKeyField.setAccessible(true);
                    Object actionKeyValue = actionKeyField.get(this);
                    actionKeyString += actionKeyValue == null ? "" : actionKeyValue.toString();
                    if(this._$actionKey.indexOf(actionKeyName) != this._$actionKey.size()-1){
                        actionKeyString += ":";
                    }
                    actionKeyField.setAccessible(true);
                }


                ArrayList<String> thisActionLayoutRule = this.bodyRule.get(actionKeyString);

                if (thisActionLayoutRule == null) {
                    thisActionLayoutRule = new ArrayList<String>();
                }

                for (Field bodyField : this.privatebodyMemeberList) {
                    String bodyFieldName = bodyField.getName();

                    Object value = bodyField.get(this);

                    boolean isInLog = false;
                    if (value != null) {
                        if ((value instanceof String) || (value instanceof Long) || (value instanceof Double) || (value instanceof JSONObject)) {
                            isInLog = true;
                        } else if ((value instanceof List) && (((List) value).size() > 0)) {
                            isInLog = true;
                        } else if ((value instanceof Map) && (((Map) value).size() > 0)) {
                            isInLog = true;
                        }
                    }

                    if (isInLog) {
                        if (value == null) {
                            body.put(bodyFieldName, "");
                        } else {
                            if (value instanceof List) {
                                body.put(bodyFieldName, new JSONArray((List) value));
                            } else if (value instanceof Map) {
                                body.put(bodyFieldName, new JSONObject((Map) value));
                            } else {
                                if (encryptedFieldsList.contains(bodyFieldName)) {
                                    body.put(bodyFieldName, getEncryptedValue(String.valueOf(value)));
                                } else {
                                    if(value instanceof String){
                                        body.put(bodyFieldName, getEscapedValue((String)value));
                                    }else{
                                        body.put(bodyFieldName, value);
                                    }
                                }
                            }
                        }
                    }
                }

                JSONObject bodyJSONOjbect = new JSONObject(body);

                return bodyJSONOjbect;
            } catch (NoSuchFieldException e) {
                e.printStackTrace();
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }


            return null;
        }


    public String bodyToString() {
        if(bodyFieldNameList.size() == 0){
            return "{}";
        }
        return getEscapedValue(this.getBody().toString());
    }


    public static JSONObject getSentinelMeta(){
        JSONObject sentinel_meta = new JSONObject();
        JSONObject container = new JSONObject();

        sentinel_meta.put("_$schemaId", _$ssSchemaId);

        JSONObject fieldOrder = new JSONObject();
        int i = 0;
        for (i = 0; i < headerFieldNameList.size(); i++) {
            fieldOrder.put(headerFieldNameList.get(i), i);
        }
        fieldOrder.put("_$body",i);
        sentinel_meta.put("_$fieldOrder", fieldOrder);

        sentinel_meta.put("_$encryptionFields",new JSONArray(encryptedFieldsList));
        sentinel_meta.put("_$projectId", _$projectId);

        container.put("sentinel_meta", sentinel_meta);

        return container;
    }


    public static JSONObject toJSONObject(JSONObject jsonObject){

        JSONObject container = new JSONObject();
        JSONObject body = new JSONObject();

        for(String name : headerFieldNameList){
            try {
                if(jsonObject.has(name)) {
                    container.put(name, jsonObject.get(name));
                }
                else {
                    container.put(name, "");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        container.put(_$logVersionKey, _$ssVersion);

        for(String name : bodyFieldNameList){
            try {
                if(jsonObject.has(name)) {
                    body.put(name, jsonObject.get(name));
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }


        container.put("_$body", body);


        container.put("sentinel_meta", getSentinelMeta().get("sentinel_meta"));

        return container;
    }


    public JSONObject toJSONObject() {
        JSONObject jsonObj = new JSONObject();


        for (Field member : privateHeaderMemeberList) {
            try {
                member.setAccessible(true);
                String key = member.getName();
                Object value = member.get(this);


                if(value != null){
                    if(encryptedFieldsList.contains(member.getName())){
                        jsonObj.put(key, getEncryptedValue(String.valueOf(value)));
                    }else{
                        if(value instanceof String){
                            jsonObj.put(key, getEscapedValue((String)value));
                        }else{
                            jsonObj.put(key, value);
                        }
                    }
                }else{
                    jsonObj.put(key, "");
                }

                member.setAccessible(false);


            } catch (IllegalAccessException e) {
                e.printStackTrace();
            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }


        jsonObj.put("_$body", this.getBody());


        jsonObj.put("sentinel_meta", getSentinelMeta().get("sentinel_meta"));

        return jsonObj;

    }

    public String toJSONString() {
        return this.toJSONObject().toString();
    }

    public String getEscapedValue(String value){
        String vt = Character.toString((char) 0x0b);
        String escapedVt = "\\"+"0x0b";
        String escaped = value.replaceAll(vt, escapedVt).replaceAll("\n","\\\\n").replaceAll("\t","\\\\t").replaceAll("\r","\\\\r");
        return escaped;
    }

    
    private void initCrypto(){
        // Do nothing
    }

    private void initCryptoOnce(){
        // Do nothing
    }

    private String getEncryptedValue(String value){
        return value;
    }

    public void setPublicKey(String modulus_n, String pub_exponent) {
        // Do nothing
    }

}
