package com.skplanet.pdp.sentinel.shuttle;

import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONArray;
import org.json.JSONTokener;

import java.lang.reflect.Field;

import java.util.Collection;
import java.util.List;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;




/*
 * Sentinel Shuttle
 *
 * Template version
 *  - 0.1.0 (2014.04.22) : support auto encryption
 *  - 0.1.1 (2014.05.28) : sentinel_meta
 *  - 0.1.2 (2014.07.17) : \r escaping
 *  - 0.1.3 (2014.11.11) : remove _$ssToken
 *  - 0.1.4 (2014.11.21) : toJsonObject(jsonObject)
 *
 * Author
 *  - Sentinel Shuttle Generator v2.0
 *  - junghyun@sk.com (Data Infrastructure)
 */
public class LogClientTpSentinelShuttle {


    private static final String _$ssTemplateVersion = "0.1.3";
    private static final String _$ssVersion = "18.03.22:2.0.1:5";
    private static final String _$ssSchemaId = "LogClientTp";
    private static final String _$ssDelim = "\t";
    private static final ArrayList<String> _$actionKey = new ArrayList() {{add("poc_clf");add("page_id");add("action_id");}};
    private static final String _$logVersionKey = "log_version";
    private static final String _$projectId = "projectId";

    


    /**
     * Fields
     */
    private static final ArrayList<String> headerFieldNameList = new ArrayList<String>(){{
		add("poc_clf");
		add("page_id");
		add("action_id");
		add("base_time");
		add("local_time");
		add("recv_time");
		add("os_name");
		add("os_version");
		add("resolution");
		add("screen_width");
		add("screen_height");
		add("language_code");
		add("rake_lib");
		add("rake_lib_version");
		add("ip");
		add("recv_host");
		add("token");
		add("log_version");
		add("device_id");
		add("device_model");
		add("manufacturer");
		add("carrier_name");
		add("network_type");
		add("app_release");
		add("app_build_number");
		add("browser_name");
		add("browser_version");
		add("referrer");
		add("url");
		add("document_title");
		add("pcid");
		add("page_version");
		add("service_country_code");
		add("service_language_code");
		add("service_currency_code");
		add("member_no");
		add("mdn");
		add("birthyear");
		add("gender_code");
		add("pf_clf");
		add("bm_clf");
		add("partner_cd");
		add("advrt_no");
		add("advrt_detail");
		add("gaid");
		add("idfa");
		add("dmpc");
		add("ab_tcs");
		add("atrb_code");
		add("session_id");
		add("xsite_session_id");
		add("eleven_device_id");
		add("app_page_type");
		add("web_log_version");
		add("partner_referrer");
		add("colloseo_ab");
		add("user_agent");
		add("reserved04");
		add("reserved05");
		add("reserved06");
		add("reserved07");
		add("reserved08");
		add("reserved09");
		add("reserved10");
		add("reserved11");
		add("reserved12");
		add("reserved13");
		add("reserved14");
		add("reserved15");
		add("reserved16");
		add("reserved17");
		add("reserved18");
		add("reserved19");
		add("reserved20");

    }};

    private static final ArrayList<String> bodyFieldNameList = new ArrayList<String>(){{
		add("abroad_delivery_tax_info_type");
		add("ad_area_gubn");
		add("ad_rank");
		add("ad_trc_no");
		add("ad_typ_gubn");
		add("ad_type");
		add("ad_type_cd");
		add("ad_yn");
		add("address_name");
		add("address_search_type");
		add("advert_statement");
		add("app_name");
		add("area_code");
		add("area_index");
		add("attribute");
		add("bank_code");
		add("basket_product_list");
		add("basket_product_option_sequence");
		add("basket_sequence");
		add("basket_sequence_list");
		add("benefit");
		add("brand_code");
		add("brand_name");
		add("brand_no");
		add("btn_name");
		add("bundle_check_index");
		add("card_company_code");
		add("card_pay_type_code");
		add("card_pay_type_name");
		add("cash_receipt_type_code");
		add("catalog_no");
		add("category_name");
		add("category_no");
		add("cell_type");
		add("check_value");
		add("colloseo_brand_add_display_category_no");
		add("colloseo_brand_code");
		add("colloseo_click_info");
		add("colloseo_id");
		add("colloseo_item_no");
		add("colloseo_mid");
		add("conten_name");
		add("content_image_url");
		add("content_link_url");
		add("content_name");
		add("content_area_name");
		add("content_no");
		add("content_type");
		add("country");
		add("coupon_issue_no");
		add("coupon_no");
		add("custom_key");
		add("custom_yn");
		add("date");
		add("date_list");
		add("delivery_company");
		add("depth");
		add("detail_category_name");
		add("detail_category_no");
		add("discount_amount");
		add("disp_space_id");
		add("disp_space_no");
		add("disp_spce_no");
		add("display_category_no");
		add("display_order");
		add("e_coupon_send_type");
		add("end_time");
		add("event_no");
		add("except_keyword");
		add("except_word");
		add("filter_category_name");
		add("filter_category_no");
		add("find_type");
		add("from_time");
		add("generalproduct_prd_cnt");
		add("generalproduct_sub_cnt");
		add("hotkeyword");
		add("include_keyword");
		add("included_ad_type");
		add("index");
		add("input_value");
		add("installment_period_value");
		add("is_adult_product");
		add("is_life_plus");
		add("is_mart");
		add("is_now_delivery");
		add("is_sale");
		add("keyword");
		add("large_category_name");
		add("large_category_no");
		add("last_discount_price");
		add("link_url");
		add("major_product_module_cnt");
		add("mart_basket_sequence");
		add("mart_basket_sequence_list");
		add("menu_name");
		add("meta_category_no");
		add("middle_category_name");
		add("middle_category_no");
		add("movie_name");
		add("movie_no");
		add("notice_no");
		add("number");
		add("option_name");
		add("option_no");
		add("order_no");
		add("order_object");
		add("order_quantity");
		add("order_status");
		add("page_name");
		add("page_no");
		add("page_num");
		add("parent_name");
		add("parent_no");
		add("parent_type");
		add("partner_name");
		add("payment_means_name");
		add("payment_method_code");
		add("payment_method_name");
		add("payment_method_type_name");
		add("plan_name");
		add("plan_no");
		add("position_l1");
		add("position_l2");
		add("position_l3");
		add("price_range_maximum");
		add("price_range_minimum");
		add("product_check_index");
		add("product_image_url");
		add("product_name");
		add("product_no");
		add("product_price");
		add("product_type");
		add("products");
		add("promotion_id");
		add("rank_no");
		add("search_address");
		add("search_call_id");
		add("search_keyword");
		add("search_result_cnt");
		add("search_result_num");
		add("select_value");
		add("seller_name");
		add("seller_nickname");
		add("seller_no");
		add("share_type");
		add("shoppingtalk_id");
		add("small_category_name");
		add("small_category_no");
		add("smartoption");
		add("sohoshop_name");
		add("sort_method");
		add("sort_type");
		add("specialist_name");
		add("specialist_no");
		add("start_time");
		add("stock_no");
		add("store_name");
		add("tab_name");
		add("tag_name");
		add("to_time");
		add("today");
		add("trace_meta_category_no");
		add("trc_no");
		add("user_input_search_keyword");
		add("view_type");
		add("visible");
		add("year_month");
		add("search_view_type");
		add("search_sort_type");
		add("search_include_keyword");
		add("search_category_no");
		add("search_brand_code");
		add("search_seller_nos");
		add("search_max_price");
		add("search_min_price");
		add("search_benefit");
		add("search_attribute");
		add("search_ad_show");
		add("search_custom_yn");
		add("search_custom_key");
		add("search_no_result_yn");
		add("rising_keyword");
		add("popular_keyword");
		add("sub_area");
		add("cart_draw_info");
		add("current_product_no");
		add("is_img_search");
		add("disp_spce_id");
		add("current_meta_category_no");
		add("current_meta_category_name");
		add("current_large_category_no");
		add("current_large_category_name");
		add("current_middle_category_no");
		add("current_middle_category_name");
		add("colloseo_tag");
		add("colloseo_method");
		add("colloseo_channel_id");
		add("search_cosmos_yn");
		add("group_product_no");
		add("group_product_firstview_no");
		add("group_product_category_no");
		add("group_product_count");
		add("group_product_info");
		add("select_filter");
		add("buynow_draw_info");
		add("eleven_pay_draw_info");
		add("type_list");
		add("qrsid");
		add("qrquery");
		add("search_prj");
		add("product_no_list");
		add("store_no");
		add("params");
		add("ga_label");
		add("utm_source");
		add("utm_medium");
		add("utm_campaign");
		add("utm_content");
		add("utm_term");

    }};

    private static final ArrayList<String> encryptedFieldsList = new ArrayList<String>(){{

    }};

    private String poc_clf = null;
    private String page_id = null;
    private String action_id = null;
    private String base_time = null;
    private String local_time = null;
    private String recv_time = null;
    private String os_name = null;
    private String os_version = null;
    private String resolution = null;
    private Long screen_width = null;
    private Long screen_height = null;
    private String language_code = null;
    private String rake_lib = null;
    private String rake_lib_version = null;
    private String ip = null;
    private String recv_host = null;
    private String token = null;
    private String log_version = _$ssVersion;
    private String device_id = null;
    private String device_model = null;
    private String manufacturer = null;
    private String carrier_name = null;
    private String network_type = null;
    private String app_release = null;
    private String app_build_number = null;
    private String browser_name = null;
    private String browser_version = null;
    private String referrer = null;
    private String url = null;
    private String document_title = null;
    private String pcid = null;
    private Long page_version = null;
    private String service_country_code = null;
    private String service_language_code = null;
    private String service_currency_code = null;
    private String member_no = null;
    private String mdn = null;
    private String birthyear = null;
    private String gender_code = null;
    private String pf_clf = null;
    private String bm_clf = null;
    private String partner_cd = null;
    private String advrt_no = null;
    private String advrt_detail = null;
    private String gaid = null;
    private String idfa = null;
    private String dmpc = null;
    private String ab_tcs = null;
    private String atrb_code = null;
    private String session_id = null;
    private String xsite_session_id = null;
    private String eleven_device_id = null;
    private String app_page_type = null;
    private String web_log_version = null;
    private String partner_referrer = null;
    private String colloseo_ab = null;
    private String user_agent = null;
    private String reserved04 = null;
    private String reserved05 = null;
    private String reserved06 = null;
    private String reserved07 = null;
    private String reserved08 = null;
    private String reserved09 = null;
    private String reserved10 = null;
    private String reserved11 = null;
    private String reserved12 = null;
    private String reserved13 = null;
    private String reserved14 = null;
    private String reserved15 = null;
    private String reserved16 = null;
    private String reserved17 = null;
    private String reserved18 = null;
    private String reserved19 = null;
    private String reserved20 = null;
    private String abroad_delivery_tax_info_type = null;
    private String ad_area_gubn = null;
    private String ad_rank = null;
    private Long ad_trc_no = null;
    private String ad_typ_gubn = null;
    private String ad_type = null;
    private String ad_type_cd = null;
    private String ad_yn = null;
    private String address_name = null;
    private String address_search_type = null;
    private String advert_statement = null;
    private String app_name = null;
    private Long area_code = null;
    private Long area_index = null;
    private String attribute = null;
    private String bank_code = null;
    private String basket_product_list = null;
    private Long basket_product_option_sequence = null;
    private String basket_sequence = null;
    private String basket_sequence_list = null;
    private String benefit = null;
    private String brand_code = null;
    private String brand_name = null;
    private Long brand_no = null;
    private String btn_name = null;
    private String bundle_check_index = null;
    private String card_company_code = null;
    private String card_pay_type_code = null;
    private String card_pay_type_name = null;
    private String cash_receipt_type_code = null;
    private Long catalog_no = null;
    private String category_name = null;
    private Long category_no = null;
    private String cell_type = null;
    private String check_value = null;
    private Long colloseo_brand_add_display_category_no = null;
    private String colloseo_brand_code = null;
    private String colloseo_click_info = null;
    private String colloseo_id = null;
    private Long colloseo_item_no = null;
    private String colloseo_mid = null;
    private String conten_name = null;
    private String content_image_url = null;
    private String content_link_url = null;
    private String content_name = null;
    private String content_area_name = null;
    private String content_no = null;
    private String content_type = null;
    private String country = null;
    private Long coupon_issue_no = null;
    private Long coupon_no = null;
    private String custom_key = null;
    private String custom_yn = null;
    private String date = null;
    private String date_list = null;
    private String delivery_company = null;
    private String depth = null;
    private String detail_category_name = null;
    private Long detail_category_no = null;
    private String discount_amount = null;
    private String disp_space_id = null;
    private Long disp_space_no = null;
    private String disp_spce_no = null;
    private Long display_category_no = null;
    private String display_order = null;
    private String e_coupon_send_type = null;
    private String end_time = null;
    private Long event_no = null;
    private String except_keyword = null;
    private String except_word = null;
    private String filter_category_name = null;
    private Long filter_category_no = null;
    private String find_type = null;
    private String from_time = null;
    private String generalproduct_prd_cnt = null;
    private String generalproduct_sub_cnt = null;
    private String hotkeyword = null;
    private String include_keyword = null;
    private String included_ad_type = null;
    private Long index = null;
    private String input_value = null;
    private String installment_period_value = null;
    private String is_adult_product = null;
    private String is_life_plus = null;
    private String is_mart = null;
    private String is_now_delivery = null;
    private String is_sale = null;
    private String keyword = null;
    private String large_category_name = null;
    private Long large_category_no = null;
    private Long last_discount_price = null;
    private String link_url = null;
    private String major_product_module_cnt = null;
    private Long mart_basket_sequence = null;
    private String mart_basket_sequence_list = null;
    private String menu_name = null;
    private Long meta_category_no = null;
    private String middle_category_name = null;
    private Long middle_category_no = null;
    private String movie_name = null;
    private Long movie_no = null;
    private Long notice_no = null;
    private String number = null;
    private String option_name = null;
    private Long option_no = null;
    private Long order_no = null;
    private JSONObject order_object = null;
    private String order_quantity = null;
    private String order_status = null;
    private String page_name = null;
    private Long page_no = null;
    private String page_num = null;
    private String parent_name = null;
    private String parent_no = null;
    private String parent_type = null;
    private String partner_name = null;
    private String payment_means_name = null;
    private String payment_method_code = null;
    private String payment_method_name = null;
    private String payment_method_type_name = null;
    private String plan_name = null;
    private Long plan_no = null;
    private Long position_l1 = null;
    private Long position_l2 = null;
    private Long position_l3 = null;
    private String price_range_maximum = null;
    private String price_range_minimum = null;
    private Long product_check_index = null;
    private String product_image_url = null;
    private String product_name = null;
    private Long product_no = null;
    private Long product_price = null;
    private String product_type = null;
    private String products = null;
    private String promotion_id = null;
    private Long rank_no = null;
    private String search_address = null;
    private String search_call_id = null;
    private String search_keyword = null;
    private String search_result_cnt = null;
    private String search_result_num = null;
    private String select_value = null;
    private String seller_name = null;
    private String seller_nickname = null;
    private String seller_no = null;
    private String share_type = null;
    private String shoppingtalk_id = null;
    private String small_category_name = null;
    private Long small_category_no = null;
    private String smartoption = null;
    private String sohoshop_name = null;
    private String sort_method = null;
    private String sort_type = null;
    private String specialist_name = null;
    private Long specialist_no = null;
    private String start_time = null;
    private Long stock_no = null;
    private String store_name = null;
    private String tab_name = null;
    private String tag_name = null;
    private String to_time = null;
    private String today = null;
    private Long trace_meta_category_no = null;
    private Long trc_no = null;
    private String user_input_search_keyword = null;
    private String view_type = null;
    private String visible = null;
    private String year_month = null;
    private String search_view_type = null;
    private String search_sort_type = null;
    private String search_include_keyword = null;
    private Long search_category_no = null;
    private String search_brand_code = null;
    private String search_seller_nos = null;
    private Long search_max_price = null;
    private Long search_min_price = null;
    private String search_benefit = null;
    private String search_attribute = null;
    private String search_ad_show = null;
    private String search_custom_yn = null;
    private String search_custom_key = null;
    private String search_no_result_yn = null;
    private String rising_keyword = null;
    private String popular_keyword = null;
    private String sub_area = null;
    private JSONObject cart_draw_info = null;
    private Long current_product_no = null;
    private String is_img_search = null;
    private String disp_spce_id = null;
    private Long current_meta_category_no = null;
    private String current_meta_category_name = null;
    private Long current_large_category_no = null;
    private String current_large_category_name = null;
    private Long current_middle_category_no = null;
    private String current_middle_category_name = null;
    private String colloseo_tag = null;
    private String colloseo_method = null;
    private String colloseo_channel_id = null;
    private String search_cosmos_yn = null;
    private Long group_product_no = null;
    private Long group_product_firstview_no = null;
    private Long group_product_category_no = null;
    private Long group_product_count = null;
    private String group_product_info = null;
    private String select_filter = null;
    private JSONObject buynow_draw_info = null;
    private JSONObject eleven_pay_draw_info = null;
    private String type_list = null;
    private String qrsid = null;
    private String qrquery = null;
    private JSONObject search_prj = null;
    private JSONObject product_no_list = null;
    private Long store_no = null;
    private JSONObject params = null;
    private String ga_label = null;
    private String utm_source = null;
    private String utm_medium = null;
    private String utm_campaign = null;
    private String utm_content = null;
    private String utm_term = null;



    /**
     * Methods
     */
 
    /*
     * Set poc_clf
     */
    public LogClientTpSentinelShuttle poc_clf(String poc_clf){
        this.poc_clf = poc_clf;
        return this;
    }


    /*
     * Set page_id
     */
    public LogClientTpSentinelShuttle page_id(String page_id){
        this.page_id = page_id;
        return this;
    }


    /*
     * Set action_id
     */
    public LogClientTpSentinelShuttle action_id(String action_id){
        this.action_id = action_id;
        return this;
    }


    /*
     * Set base_time
     */
    public LogClientTpSentinelShuttle base_time(String base_time){
        this.base_time = base_time;
        return this;
    }


    /*
     * Set local_time
     */
    public LogClientTpSentinelShuttle local_time(String local_time){
        this.local_time = local_time;
        return this;
    }


    /*
     * Set recv_time
     */
    public LogClientTpSentinelShuttle recv_time(String recv_time){
        this.recv_time = recv_time;
        return this;
    }


    /*
     * Set os_name
     */
    public LogClientTpSentinelShuttle os_name(String os_name){
        this.os_name = os_name;
        return this;
    }


    /*
     * Set os_version
     */
    public LogClientTpSentinelShuttle os_version(String os_version){
        this.os_version = os_version;
        return this;
    }


    /*
     * Set resolution
     */
    public LogClientTpSentinelShuttle resolution(String resolution){
        this.resolution = resolution;
        return this;
    }


    /*
     * Set screen_width
     */
    public LogClientTpSentinelShuttle screen_width(Long screen_width){
        this.screen_width = screen_width;
        return this;
    }


    /*
     * Set screen_height
     */
    public LogClientTpSentinelShuttle screen_height(Long screen_height){
        this.screen_height = screen_height;
        return this;
    }


    /*
     * Set language_code
     */
    public LogClientTpSentinelShuttle language_code(String language_code){
        this.language_code = language_code;
        return this;
    }


    /*
     * Set rake_lib
     */
    public LogClientTpSentinelShuttle rake_lib(String rake_lib){
        this.rake_lib = rake_lib;
        return this;
    }


    /*
     * Set rake_lib_version
     */
    public LogClientTpSentinelShuttle rake_lib_version(String rake_lib_version){
        this.rake_lib_version = rake_lib_version;
        return this;
    }


    /*
     * Set ip
     */
    public LogClientTpSentinelShuttle ip(String ip){
        this.ip = ip;
        return this;
    }


    /*
     * Set recv_host
     */
    public LogClientTpSentinelShuttle recv_host(String recv_host){
        this.recv_host = recv_host;
        return this;
    }


    /*
     * Set token
     */
    public LogClientTpSentinelShuttle token(String token){
        this.token = token;
        return this;
    }


    /*
     * Set log_version
     */
    private LogClientTpSentinelShuttle log_version(String log_version){
        this.log_version = log_version;
        return this;
    }


    /*
     * Set device_id
     */
    public LogClientTpSentinelShuttle device_id(String device_id){
        this.device_id = device_id;
        return this;
    }


    /*
     * Set device_model
     */
    public LogClientTpSentinelShuttle device_model(String device_model){
        this.device_model = device_model;
        return this;
    }


    /*
     * Set manufacturer
     */
    public LogClientTpSentinelShuttle manufacturer(String manufacturer){
        this.manufacturer = manufacturer;
        return this;
    }


    /*
     * Set carrier_name
     */
    public LogClientTpSentinelShuttle carrier_name(String carrier_name){
        this.carrier_name = carrier_name;
        return this;
    }


    /*
     * Set network_type
     */
    public LogClientTpSentinelShuttle network_type(String network_type){
        this.network_type = network_type;
        return this;
    }


    /*
     * Set app_release
     */
    public LogClientTpSentinelShuttle app_release(String app_release){
        this.app_release = app_release;
        return this;
    }


    /*
     * Set app_build_number
     */
    public LogClientTpSentinelShuttle app_build_number(String app_build_number){
        this.app_build_number = app_build_number;
        return this;
    }


    /*
     * Set browser_name
     */
    public LogClientTpSentinelShuttle browser_name(String browser_name){
        this.browser_name = browser_name;
        return this;
    }


    /*
     * Set browser_version
     */
    public LogClientTpSentinelShuttle browser_version(String browser_version){
        this.browser_version = browser_version;
        return this;
    }


    /*
     * Set referrer
     */
    public LogClientTpSentinelShuttle referrer(String referrer){
        this.referrer = referrer;
        return this;
    }


    /*
     * Set url
     */
    public LogClientTpSentinelShuttle url(String url){
        this.url = url;
        return this;
    }


    /*
     * Set document_title
     */
    public LogClientTpSentinelShuttle document_title(String document_title){
        this.document_title = document_title;
        return this;
    }


    /*
     * Set pcid
     */
    public LogClientTpSentinelShuttle pcid(String pcid){
        this.pcid = pcid;
        return this;
    }


    /*
     * Set page_version
     */
    public LogClientTpSentinelShuttle page_version(Long page_version){
        this.page_version = page_version;
        return this;
    }


    /*
     * Set service_country_code
     */
    public LogClientTpSentinelShuttle service_country_code(String service_country_code){
        this.service_country_code = service_country_code;
        return this;
    }


    /*
     * Set service_language_code
     */
    public LogClientTpSentinelShuttle service_language_code(String service_language_code){
        this.service_language_code = service_language_code;
        return this;
    }


    /*
     * Set service_currency_code
     */
    public LogClientTpSentinelShuttle service_currency_code(String service_currency_code){
        this.service_currency_code = service_currency_code;
        return this;
    }


    /*
     * Set member_no
     */
    public LogClientTpSentinelShuttle member_no(String member_no){
        this.member_no = member_no;
        return this;
    }


    /*
     * Set mdn
     */
    public LogClientTpSentinelShuttle mdn(String mdn){
        this.mdn = mdn;
        return this;
    }


    /*
     * Set birthyear
     */
    public LogClientTpSentinelShuttle birthyear(String birthyear){
        this.birthyear = birthyear;
        return this;
    }


    /*
     * Set gender_code
     */
    public LogClientTpSentinelShuttle gender_code(String gender_code){
        this.gender_code = gender_code;
        return this;
    }


    /*
     * Set pf_clf
     */
    public LogClientTpSentinelShuttle pf_clf(String pf_clf){
        this.pf_clf = pf_clf;
        return this;
    }


    /*
     * Set bm_clf
     */
    public LogClientTpSentinelShuttle bm_clf(String bm_clf){
        this.bm_clf = bm_clf;
        return this;
    }


    /*
     * Set partner_cd
     */
    public LogClientTpSentinelShuttle partner_cd(String partner_cd){
        this.partner_cd = partner_cd;
        return this;
    }


    /*
     * Set advrt_no
     */
    public LogClientTpSentinelShuttle advrt_no(String advrt_no){
        this.advrt_no = advrt_no;
        return this;
    }


    /*
     * Set advrt_detail
     */
    public LogClientTpSentinelShuttle advrt_detail(String advrt_detail){
        this.advrt_detail = advrt_detail;
        return this;
    }


    /*
     * Set gaid
     */
    public LogClientTpSentinelShuttle gaid(String gaid){
        this.gaid = gaid;
        return this;
    }


    /*
     * Set idfa
     */
    public LogClientTpSentinelShuttle idfa(String idfa){
        this.idfa = idfa;
        return this;
    }


    /*
     * Set dmpc
     */
    public LogClientTpSentinelShuttle dmpc(String dmpc){
        this.dmpc = dmpc;
        return this;
    }


    /*
     * Set ab_tcs
     */
    public LogClientTpSentinelShuttle ab_tcs(String ab_tcs){
        this.ab_tcs = ab_tcs;
        return this;
    }


    /*
     * Set atrb_code
     */
    public LogClientTpSentinelShuttle atrb_code(String atrb_code){
        this.atrb_code = atrb_code;
        return this;
    }


    /*
     * Set session_id
     */
    public LogClientTpSentinelShuttle session_id(String session_id){
        this.session_id = session_id;
        return this;
    }


    /*
     * Set xsite_session_id
     */
    public LogClientTpSentinelShuttle xsite_session_id(String xsite_session_id){
        this.xsite_session_id = xsite_session_id;
        return this;
    }


    /*
     * Set eleven_device_id
     */
    public LogClientTpSentinelShuttle eleven_device_id(String eleven_device_id){
        this.eleven_device_id = eleven_device_id;
        return this;
    }


    /*
     * Set app_page_type
     */
    public LogClientTpSentinelShuttle app_page_type(String app_page_type){
        this.app_page_type = app_page_type;
        return this;
    }


    /*
     * Set web_log_version
     */
    public LogClientTpSentinelShuttle web_log_version(String web_log_version){
        this.web_log_version = web_log_version;
        return this;
    }


    /*
     * Set partner_referrer
     */
    public LogClientTpSentinelShuttle partner_referrer(String partner_referrer){
        this.partner_referrer = partner_referrer;
        return this;
    }


    /*
     * Set colloseo_ab
     */
    public LogClientTpSentinelShuttle colloseo_ab(String colloseo_ab){
        this.colloseo_ab = colloseo_ab;
        return this;
    }


    /*
     * Set user_agent
     */
    public LogClientTpSentinelShuttle user_agent(String user_agent){
        this.user_agent = user_agent;
        return this;
    }


    /*
     * Set reserved04
     */
    public LogClientTpSentinelShuttle reserved04(String reserved04){
        this.reserved04 = reserved04;
        return this;
    }


    /*
     * Set reserved05
     */
    public LogClientTpSentinelShuttle reserved05(String reserved05){
        this.reserved05 = reserved05;
        return this;
    }


    /*
     * Set reserved06
     */
    public LogClientTpSentinelShuttle reserved06(String reserved06){
        this.reserved06 = reserved06;
        return this;
    }


    /*
     * Set reserved07
     */
    public LogClientTpSentinelShuttle reserved07(String reserved07){
        this.reserved07 = reserved07;
        return this;
    }


    /*
     * Set reserved08
     */
    public LogClientTpSentinelShuttle reserved08(String reserved08){
        this.reserved08 = reserved08;
        return this;
    }


    /*
     * Set reserved09
     */
    public LogClientTpSentinelShuttle reserved09(String reserved09){
        this.reserved09 = reserved09;
        return this;
    }


    /*
     * Set reserved10
     */
    public LogClientTpSentinelShuttle reserved10(String reserved10){
        this.reserved10 = reserved10;
        return this;
    }


    /*
     * Set reserved11
     */
    public LogClientTpSentinelShuttle reserved11(String reserved11){
        this.reserved11 = reserved11;
        return this;
    }


    /*
     * Set reserved12
     */
    public LogClientTpSentinelShuttle reserved12(String reserved12){
        this.reserved12 = reserved12;
        return this;
    }


    /*
     * Set reserved13
     */
    public LogClientTpSentinelShuttle reserved13(String reserved13){
        this.reserved13 = reserved13;
        return this;
    }


    /*
     * Set reserved14
     */
    public LogClientTpSentinelShuttle reserved14(String reserved14){
        this.reserved14 = reserved14;
        return this;
    }


    /*
     * Set reserved15
     */
    public LogClientTpSentinelShuttle reserved15(String reserved15){
        this.reserved15 = reserved15;
        return this;
    }


    /*
     * Set reserved16
     */
    public LogClientTpSentinelShuttle reserved16(String reserved16){
        this.reserved16 = reserved16;
        return this;
    }


    /*
     * Set reserved17
     */
    public LogClientTpSentinelShuttle reserved17(String reserved17){
        this.reserved17 = reserved17;
        return this;
    }


    /*
     * Set reserved18
     */
    public LogClientTpSentinelShuttle reserved18(String reserved18){
        this.reserved18 = reserved18;
        return this;
    }


    /*
     * Set reserved19
     */
    public LogClientTpSentinelShuttle reserved19(String reserved19){
        this.reserved19 = reserved19;
        return this;
    }


    /*
     * Set reserved20
     */
    public LogClientTpSentinelShuttle reserved20(String reserved20){
        this.reserved20 = reserved20;
        return this;
    }


    /*
     * Set abroad_delivery_tax_info_type
     */
    public LogClientTpSentinelShuttle abroad_delivery_tax_info_type(String abroad_delivery_tax_info_type){
        this.abroad_delivery_tax_info_type = abroad_delivery_tax_info_type;
        return this;
    }


    /*
     * Set ad_area_gubn
     */
    public LogClientTpSentinelShuttle ad_area_gubn(String ad_area_gubn){
        this.ad_area_gubn = ad_area_gubn;
        return this;
    }


    /*
     * Set ad_rank
     */
    public LogClientTpSentinelShuttle ad_rank(String ad_rank){
        this.ad_rank = ad_rank;
        return this;
    }


    /*
     * Set ad_trc_no
     */
    public LogClientTpSentinelShuttle ad_trc_no(Long ad_trc_no){
        this.ad_trc_no = ad_trc_no;
        return this;
    }


    /*
     * Set ad_typ_gubn
     */
    public LogClientTpSentinelShuttle ad_typ_gubn(String ad_typ_gubn){
        this.ad_typ_gubn = ad_typ_gubn;
        return this;
    }


    /*
     * Set ad_type
     */
    public LogClientTpSentinelShuttle ad_type(String ad_type){
        this.ad_type = ad_type;
        return this;
    }


    /*
     * Set ad_type_cd
     */
    public LogClientTpSentinelShuttle ad_type_cd(String ad_type_cd){
        this.ad_type_cd = ad_type_cd;
        return this;
    }


    /*
     * Set ad_yn
     */
    public LogClientTpSentinelShuttle ad_yn(String ad_yn){
        this.ad_yn = ad_yn;
        return this;
    }


    /*
     * Set address_name
     */
    public LogClientTpSentinelShuttle address_name(String address_name){
        this.address_name = address_name;
        return this;
    }


    /*
     * Set address_search_type
     */
    public LogClientTpSentinelShuttle address_search_type(String address_search_type){
        this.address_search_type = address_search_type;
        return this;
    }


    /*
     * Set advert_statement
     */
    public LogClientTpSentinelShuttle advert_statement(String advert_statement){
        this.advert_statement = advert_statement;
        return this;
    }


    /*
     * Set app_name
     */
    public LogClientTpSentinelShuttle app_name(String app_name){
        this.app_name = app_name;
        return this;
    }


    /*
     * Set area_code
     */
    public LogClientTpSentinelShuttle area_code(Long area_code){
        this.area_code = area_code;
        return this;
    }


    /*
     * Set area_index
     */
    public LogClientTpSentinelShuttle area_index(Long area_index){
        this.area_index = area_index;
        return this;
    }


    /*
     * Set attribute
     */
    public LogClientTpSentinelShuttle attribute(String attribute){
        this.attribute = attribute;
        return this;
    }


    /*
     * Set bank_code
     */
    public LogClientTpSentinelShuttle bank_code(String bank_code){
        this.bank_code = bank_code;
        return this;
    }


    /*
     * Set basket_product_list
     */
    public LogClientTpSentinelShuttle basket_product_list(String basket_product_list){
        this.basket_product_list = basket_product_list;
        return this;
    }


    /*
     * Set basket_product_option_sequence
     */
    public LogClientTpSentinelShuttle basket_product_option_sequence(Long basket_product_option_sequence){
        this.basket_product_option_sequence = basket_product_option_sequence;
        return this;
    }


    /*
     * Set basket_sequence
     */
    public LogClientTpSentinelShuttle basket_sequence(String basket_sequence){
        this.basket_sequence = basket_sequence;
        return this;
    }


    /*
     * Set basket_sequence_list
     */
    public LogClientTpSentinelShuttle basket_sequence_list(String basket_sequence_list){
        this.basket_sequence_list = basket_sequence_list;
        return this;
    }


    /*
     * Set benefit
     */
    public LogClientTpSentinelShuttle benefit(String benefit){
        this.benefit = benefit;
        return this;
    }


    /*
     * Set brand_code
     */
    public LogClientTpSentinelShuttle brand_code(String brand_code){
        this.brand_code = brand_code;
        return this;
    }


    /*
     * Set brand_name
     */
    public LogClientTpSentinelShuttle brand_name(String brand_name){
        this.brand_name = brand_name;
        return this;
    }


    /*
     * Set brand_no
     */
    public LogClientTpSentinelShuttle brand_no(Long brand_no){
        this.brand_no = brand_no;
        return this;
    }


    /*
     * Set btn_name
     */
    public LogClientTpSentinelShuttle btn_name(String btn_name){
        this.btn_name = btn_name;
        return this;
    }


    /*
     * Set bundle_check_index
     */
    public LogClientTpSentinelShuttle bundle_check_index(String bundle_check_index){
        this.bundle_check_index = bundle_check_index;
        return this;
    }


    /*
     * Set card_company_code
     */
    public LogClientTpSentinelShuttle card_company_code(String card_company_code){
        this.card_company_code = card_company_code;
        return this;
    }


    /*
     * Set card_pay_type_code
     */
    public LogClientTpSentinelShuttle card_pay_type_code(String card_pay_type_code){
        this.card_pay_type_code = card_pay_type_code;
        return this;
    }


    /*
     * Set card_pay_type_name
     */
    public LogClientTpSentinelShuttle card_pay_type_name(String card_pay_type_name){
        this.card_pay_type_name = card_pay_type_name;
        return this;
    }


    /*
     * Set cash_receipt_type_code
     */
    public LogClientTpSentinelShuttle cash_receipt_type_code(String cash_receipt_type_code){
        this.cash_receipt_type_code = cash_receipt_type_code;
        return this;
    }


    /*
     * Set catalog_no
     */
    public LogClientTpSentinelShuttle catalog_no(Long catalog_no){
        this.catalog_no = catalog_no;
        return this;
    }


    /*
     * Set category_name
     */
    public LogClientTpSentinelShuttle category_name(String category_name){
        this.category_name = category_name;
        return this;
    }


    /*
     * Set category_no
     */
    public LogClientTpSentinelShuttle category_no(Long category_no){
        this.category_no = category_no;
        return this;
    }


    /*
     * Set cell_type
     */
    public LogClientTpSentinelShuttle cell_type(String cell_type){
        this.cell_type = cell_type;
        return this;
    }


    /*
     * Set check_value
     */
    public LogClientTpSentinelShuttle check_value(String check_value){
        this.check_value = check_value;
        return this;
    }


    /*
     * Set colloseo_brand_add_display_category_no
     */
    public LogClientTpSentinelShuttle colloseo_brand_add_display_category_no(Long colloseo_brand_add_display_category_no){
        this.colloseo_brand_add_display_category_no = colloseo_brand_add_display_category_no;
        return this;
    }


    /*
     * Set colloseo_brand_code
     */
    public LogClientTpSentinelShuttle colloseo_brand_code(String colloseo_brand_code){
        this.colloseo_brand_code = colloseo_brand_code;
        return this;
    }


    /*
     * Set colloseo_click_info
     */
    public LogClientTpSentinelShuttle colloseo_click_info(String colloseo_click_info){
        this.colloseo_click_info = colloseo_click_info;
        return this;
    }


    /*
     * Set colloseo_id
     */
    public LogClientTpSentinelShuttle colloseo_id(String colloseo_id){
        this.colloseo_id = colloseo_id;
        return this;
    }


    /*
     * Set colloseo_item_no
     */
    public LogClientTpSentinelShuttle colloseo_item_no(Long colloseo_item_no){
        this.colloseo_item_no = colloseo_item_no;
        return this;
    }


    /*
     * Set colloseo_mid
     */
    public LogClientTpSentinelShuttle colloseo_mid(String colloseo_mid){
        this.colloseo_mid = colloseo_mid;
        return this;
    }


    /*
     * Set conten_name
     */
    public LogClientTpSentinelShuttle conten_name(String conten_name){
        this.conten_name = conten_name;
        return this;
    }


    /*
     * Set content_image_url
     */
    public LogClientTpSentinelShuttle content_image_url(String content_image_url){
        this.content_image_url = content_image_url;
        return this;
    }


    /*
     * Set content_link_url
     */
    public LogClientTpSentinelShuttle content_link_url(String content_link_url){
        this.content_link_url = content_link_url;
        return this;
    }


    /*
     * Set content_name
     */
    public LogClientTpSentinelShuttle content_name(String content_name){
        this.content_name = content_name;
        return this;
    }


    /*
     * Set content_area_name
     */
    public LogClientTpSentinelShuttle content_area_name(String content_area_name){
        this.content_area_name = content_area_name;
        return this;
    }


    /*
     * Set content_no
     */
    public LogClientTpSentinelShuttle content_no(String content_no){
        this.content_no = content_no;
        return this;
    }


    /*
     * Set content_type
     */
    public LogClientTpSentinelShuttle content_type(String content_type){
        this.content_type = content_type;
        return this;
    }


    /*
     * Set country
     */
    public LogClientTpSentinelShuttle country(String country){
        this.country = country;
        return this;
    }


    /*
     * Set coupon_issue_no
     */
    public LogClientTpSentinelShuttle coupon_issue_no(Long coupon_issue_no){
        this.coupon_issue_no = coupon_issue_no;
        return this;
    }


    /*
     * Set coupon_no
     */
    public LogClientTpSentinelShuttle coupon_no(Long coupon_no){
        this.coupon_no = coupon_no;
        return this;
    }


    /*
     * Set custom_key
     */
    public LogClientTpSentinelShuttle custom_key(String custom_key){
        this.custom_key = custom_key;
        return this;
    }


    /*
     * Set custom_yn
     */
    public LogClientTpSentinelShuttle custom_yn(String custom_yn){
        this.custom_yn = custom_yn;
        return this;
    }


    /*
     * Set date
     */
    public LogClientTpSentinelShuttle date(String date){
        this.date = date;
        return this;
    }


    /*
     * Set date_list
     */
    public LogClientTpSentinelShuttle date_list(String date_list){
        this.date_list = date_list;
        return this;
    }


    /*
     * Set delivery_company
     */
    public LogClientTpSentinelShuttle delivery_company(String delivery_company){
        this.delivery_company = delivery_company;
        return this;
    }


    /*
     * Set depth
     */
    public LogClientTpSentinelShuttle depth(String depth){
        this.depth = depth;
        return this;
    }


    /*
     * Set detail_category_name
     */
    public LogClientTpSentinelShuttle detail_category_name(String detail_category_name){
        this.detail_category_name = detail_category_name;
        return this;
    }


    /*
     * Set detail_category_no
     */
    public LogClientTpSentinelShuttle detail_category_no(Long detail_category_no){
        this.detail_category_no = detail_category_no;
        return this;
    }


    /*
     * Set discount_amount
     */
    public LogClientTpSentinelShuttle discount_amount(String discount_amount){
        this.discount_amount = discount_amount;
        return this;
    }


    /*
     * Set disp_space_id
     */
    public LogClientTpSentinelShuttle disp_space_id(String disp_space_id){
        this.disp_space_id = disp_space_id;
        return this;
    }


    /*
     * Set disp_space_no
     */
    public LogClientTpSentinelShuttle disp_space_no(Long disp_space_no){
        this.disp_space_no = disp_space_no;
        return this;
    }


    /*
     * Set disp_spce_no
     */
    public LogClientTpSentinelShuttle disp_spce_no(String disp_spce_no){
        this.disp_spce_no = disp_spce_no;
        return this;
    }


    /*
     * Set display_category_no
     */
    public LogClientTpSentinelShuttle display_category_no(Long display_category_no){
        this.display_category_no = display_category_no;
        return this;
    }


    /*
     * Set display_order
     */
    public LogClientTpSentinelShuttle display_order(String display_order){
        this.display_order = display_order;
        return this;
    }


    /*
     * Set e_coupon_send_type
     */
    public LogClientTpSentinelShuttle e_coupon_send_type(String e_coupon_send_type){
        this.e_coupon_send_type = e_coupon_send_type;
        return this;
    }


    /*
     * Set end_time
     */
    public LogClientTpSentinelShuttle end_time(String end_time){
        this.end_time = end_time;
        return this;
    }


    /*
     * Set event_no
     */
    public LogClientTpSentinelShuttle event_no(Long event_no){
        this.event_no = event_no;
        return this;
    }


    /*
     * Set except_keyword
     */
    public LogClientTpSentinelShuttle except_keyword(String except_keyword){
        this.except_keyword = except_keyword;
        return this;
    }


    /*
     * Set except_word
     */
    public LogClientTpSentinelShuttle except_word(String except_word){
        this.except_word = except_word;
        return this;
    }


    /*
     * Set filter_category_name
     */
    public LogClientTpSentinelShuttle filter_category_name(String filter_category_name){
        this.filter_category_name = filter_category_name;
        return this;
    }


    /*
     * Set filter_category_no
     */
    public LogClientTpSentinelShuttle filter_category_no(Long filter_category_no){
        this.filter_category_no = filter_category_no;
        return this;
    }


    /*
     * Set find_type
     */
    public LogClientTpSentinelShuttle find_type(String find_type){
        this.find_type = find_type;
        return this;
    }


    /*
     * Set from_time
     */
    public LogClientTpSentinelShuttle from_time(String from_time){
        this.from_time = from_time;
        return this;
    }


    /*
     * Set generalproduct_prd_cnt
     */
    public LogClientTpSentinelShuttle generalproduct_prd_cnt(String generalproduct_prd_cnt){
        this.generalproduct_prd_cnt = generalproduct_prd_cnt;
        return this;
    }


    /*
     * Set generalproduct_sub_cnt
     */
    public LogClientTpSentinelShuttle generalproduct_sub_cnt(String generalproduct_sub_cnt){
        this.generalproduct_sub_cnt = generalproduct_sub_cnt;
        return this;
    }


    /*
     * Set hotkeyword
     */
    public LogClientTpSentinelShuttle hotkeyword(String hotkeyword){
        this.hotkeyword = hotkeyword;
        return this;
    }


    /*
     * Set include_keyword
     */
    public LogClientTpSentinelShuttle include_keyword(String include_keyword){
        this.include_keyword = include_keyword;
        return this;
    }


    /*
     * Set included_ad_type
     */
    public LogClientTpSentinelShuttle included_ad_type(String included_ad_type){
        this.included_ad_type = included_ad_type;
        return this;
    }


    /*
     * Set index
     */
    public LogClientTpSentinelShuttle index(Long index){
        this.index = index;
        return this;
    }


    /*
     * Set input_value
     */
    public LogClientTpSentinelShuttle input_value(String input_value){
        this.input_value = input_value;
        return this;
    }


    /*
     * Set installment_period_value
     */
    public LogClientTpSentinelShuttle installment_period_value(String installment_period_value){
        this.installment_period_value = installment_period_value;
        return this;
    }


    /*
     * Set is_adult_product
     */
    public LogClientTpSentinelShuttle is_adult_product(String is_adult_product){
        this.is_adult_product = is_adult_product;
        return this;
    }


    /*
     * Set is_life_plus
     */
    public LogClientTpSentinelShuttle is_life_plus(String is_life_plus){
        this.is_life_plus = is_life_plus;
        return this;
    }


    /*
     * Set is_mart
     */
    public LogClientTpSentinelShuttle is_mart(String is_mart){
        this.is_mart = is_mart;
        return this;
    }


    /*
     * Set is_now_delivery
     */
    public LogClientTpSentinelShuttle is_now_delivery(String is_now_delivery){
        this.is_now_delivery = is_now_delivery;
        return this;
    }


    /*
     * Set is_sale
     */
    public LogClientTpSentinelShuttle is_sale(String is_sale){
        this.is_sale = is_sale;
        return this;
    }


    /*
     * Set keyword
     */
    public LogClientTpSentinelShuttle keyword(String keyword){
        this.keyword = keyword;
        return this;
    }


    /*
     * Set large_category_name
     */
    public LogClientTpSentinelShuttle large_category_name(String large_category_name){
        this.large_category_name = large_category_name;
        return this;
    }


    /*
     * Set large_category_no
     */
    public LogClientTpSentinelShuttle large_category_no(Long large_category_no){
        this.large_category_no = large_category_no;
        return this;
    }


    /*
     * Set last_discount_price
     */
    public LogClientTpSentinelShuttle last_discount_price(Long last_discount_price){
        this.last_discount_price = last_discount_price;
        return this;
    }


    /*
     * Set link_url
     */
    public LogClientTpSentinelShuttle link_url(String link_url){
        this.link_url = link_url;
        return this;
    }


    /*
     * Set major_product_module_cnt
     */
    public LogClientTpSentinelShuttle major_product_module_cnt(String major_product_module_cnt){
        this.major_product_module_cnt = major_product_module_cnt;
        return this;
    }


    /*
     * Set mart_basket_sequence
     */
    public LogClientTpSentinelShuttle mart_basket_sequence(Long mart_basket_sequence){
        this.mart_basket_sequence = mart_basket_sequence;
        return this;
    }


    /*
     * Set mart_basket_sequence_list
     */
    public LogClientTpSentinelShuttle mart_basket_sequence_list(String mart_basket_sequence_list){
        this.mart_basket_sequence_list = mart_basket_sequence_list;
        return this;
    }


    /*
     * Set menu_name
     */
    public LogClientTpSentinelShuttle menu_name(String menu_name){
        this.menu_name = menu_name;
        return this;
    }


    /*
     * Set meta_category_no
     */
    public LogClientTpSentinelShuttle meta_category_no(Long meta_category_no){
        this.meta_category_no = meta_category_no;
        return this;
    }


    /*
     * Set middle_category_name
     */
    public LogClientTpSentinelShuttle middle_category_name(String middle_category_name){
        this.middle_category_name = middle_category_name;
        return this;
    }


    /*
     * Set middle_category_no
     */
    public LogClientTpSentinelShuttle middle_category_no(Long middle_category_no){
        this.middle_category_no = middle_category_no;
        return this;
    }


    /*
     * Set movie_name
     */
    public LogClientTpSentinelShuttle movie_name(String movie_name){
        this.movie_name = movie_name;
        return this;
    }


    /*
     * Set movie_no
     */
    public LogClientTpSentinelShuttle movie_no(Long movie_no){
        this.movie_no = movie_no;
        return this;
    }


    /*
     * Set notice_no
     */
    public LogClientTpSentinelShuttle notice_no(Long notice_no){
        this.notice_no = notice_no;
        return this;
    }


    /*
     * Set number
     */
    public LogClientTpSentinelShuttle number(String number){
        this.number = number;
        return this;
    }


    /*
     * Set option_name
     */
    public LogClientTpSentinelShuttle option_name(String option_name){
        this.option_name = option_name;
        return this;
    }


    /*
     * Set option_no
     */
    public LogClientTpSentinelShuttle option_no(Long option_no){
        this.option_no = option_no;
        return this;
    }


    /*
     * Set order_no
     */
    public LogClientTpSentinelShuttle order_no(Long order_no){
        this.order_no = order_no;
        return this;
    }


    /*
     * Set order_object
     */
    public LogClientTpSentinelShuttle order_object(JSONObject order_object){
        this.order_object = order_object;
        return this;
    }


    /*
     * Set order_quantity
     */
    public LogClientTpSentinelShuttle order_quantity(String order_quantity){
        this.order_quantity = order_quantity;
        return this;
    }


    /*
     * Set order_status
     */
    public LogClientTpSentinelShuttle order_status(String order_status){
        this.order_status = order_status;
        return this;
    }


    /*
     * Set page_name
     */
    public LogClientTpSentinelShuttle page_name(String page_name){
        this.page_name = page_name;
        return this;
    }


    /*
     * Set page_no
     */
    public LogClientTpSentinelShuttle page_no(Long page_no){
        this.page_no = page_no;
        return this;
    }


    /*
     * Set page_num
     */
    public LogClientTpSentinelShuttle page_num(String page_num){
        this.page_num = page_num;
        return this;
    }


    /*
     * Set parent_name
     */
    public LogClientTpSentinelShuttle parent_name(String parent_name){
        this.parent_name = parent_name;
        return this;
    }


    /*
     * Set parent_no
     */
    public LogClientTpSentinelShuttle parent_no(String parent_no){
        this.parent_no = parent_no;
        return this;
    }


    /*
     * Set parent_type
     */
    public LogClientTpSentinelShuttle parent_type(String parent_type){
        this.parent_type = parent_type;
        return this;
    }


    /*
     * Set partner_name
     */
    public LogClientTpSentinelShuttle partner_name(String partner_name){
        this.partner_name = partner_name;
        return this;
    }


    /*
     * Set payment_means_name
     */
    public LogClientTpSentinelShuttle payment_means_name(String payment_means_name){
        this.payment_means_name = payment_means_name;
        return this;
    }


    /*
     * Set payment_method_code
     */
    public LogClientTpSentinelShuttle payment_method_code(String payment_method_code){
        this.payment_method_code = payment_method_code;
        return this;
    }


    /*
     * Set payment_method_name
     */
    public LogClientTpSentinelShuttle payment_method_name(String payment_method_name){
        this.payment_method_name = payment_method_name;
        return this;
    }


    /*
     * Set payment_method_type_name
     */
    public LogClientTpSentinelShuttle payment_method_type_name(String payment_method_type_name){
        this.payment_method_type_name = payment_method_type_name;
        return this;
    }


    /*
     * Set plan_name
     */
    public LogClientTpSentinelShuttle plan_name(String plan_name){
        this.plan_name = plan_name;
        return this;
    }


    /*
     * Set plan_no
     */
    public LogClientTpSentinelShuttle plan_no(Long plan_no){
        this.plan_no = plan_no;
        return this;
    }


    /*
     * Set position_l1
     */
    public LogClientTpSentinelShuttle position_l1(Long position_l1){
        this.position_l1 = position_l1;
        return this;
    }


    /*
     * Set position_l2
     */
    public LogClientTpSentinelShuttle position_l2(Long position_l2){
        this.position_l2 = position_l2;
        return this;
    }


    /*
     * Set position_l3
     */
    public LogClientTpSentinelShuttle position_l3(Long position_l3){
        this.position_l3 = position_l3;
        return this;
    }


    /*
     * Set price_range_maximum
     */
    public LogClientTpSentinelShuttle price_range_maximum(String price_range_maximum){
        this.price_range_maximum = price_range_maximum;
        return this;
    }


    /*
     * Set price_range_minimum
     */
    public LogClientTpSentinelShuttle price_range_minimum(String price_range_minimum){
        this.price_range_minimum = price_range_minimum;
        return this;
    }


    /*
     * Set product_check_index
     */
    public LogClientTpSentinelShuttle product_check_index(Long product_check_index){
        this.product_check_index = product_check_index;
        return this;
    }


    /*
     * Set product_image_url
     */
    public LogClientTpSentinelShuttle product_image_url(String product_image_url){
        this.product_image_url = product_image_url;
        return this;
    }


    /*
     * Set product_name
     */
    public LogClientTpSentinelShuttle product_name(String product_name){
        this.product_name = product_name;
        return this;
    }


    /*
     * Set product_no
     */
    public LogClientTpSentinelShuttle product_no(Long product_no){
        this.product_no = product_no;
        return this;
    }


    /*
     * Set product_price
     */
    public LogClientTpSentinelShuttle product_price(Long product_price){
        this.product_price = product_price;
        return this;
    }


    /*
     * Set product_type
     */
    public LogClientTpSentinelShuttle product_type(String product_type){
        this.product_type = product_type;
        return this;
    }


    /*
     * Set products
     */
    public LogClientTpSentinelShuttle products(String products){
        this.products = products;
        return this;
    }


    /*
     * Set promotion_id
     */
    public LogClientTpSentinelShuttle promotion_id(String promotion_id){
        this.promotion_id = promotion_id;
        return this;
    }


    /*
     * Set rank_no
     */
    public LogClientTpSentinelShuttle rank_no(Long rank_no){
        this.rank_no = rank_no;
        return this;
    }


    /*
     * Set search_address
     */
    public LogClientTpSentinelShuttle search_address(String search_address){
        this.search_address = search_address;
        return this;
    }


    /*
     * Set search_call_id
     */
    public LogClientTpSentinelShuttle search_call_id(String search_call_id){
        this.search_call_id = search_call_id;
        return this;
    }


    /*
     * Set search_keyword
     */
    public LogClientTpSentinelShuttle search_keyword(String search_keyword){
        this.search_keyword = search_keyword;
        return this;
    }


    /*
     * Set search_result_cnt
     */
    public LogClientTpSentinelShuttle search_result_cnt(String search_result_cnt){
        this.search_result_cnt = search_result_cnt;
        return this;
    }


    /*
     * Set search_result_num
     */
    public LogClientTpSentinelShuttle search_result_num(String search_result_num){
        this.search_result_num = search_result_num;
        return this;
    }


    /*
     * Set select_value
     */
    public LogClientTpSentinelShuttle select_value(String select_value){
        this.select_value = select_value;
        return this;
    }


    /*
     * Set seller_name
     */
    public LogClientTpSentinelShuttle seller_name(String seller_name){
        this.seller_name = seller_name;
        return this;
    }


    /*
     * Set seller_nickname
     */
    public LogClientTpSentinelShuttle seller_nickname(String seller_nickname){
        this.seller_nickname = seller_nickname;
        return this;
    }


    /*
     * Set seller_no
     */
    public LogClientTpSentinelShuttle seller_no(String seller_no){
        this.seller_no = seller_no;
        return this;
    }


    /*
     * Set share_type
     */
    public LogClientTpSentinelShuttle share_type(String share_type){
        this.share_type = share_type;
        return this;
    }


    /*
     * Set shoppingtalk_id
     */
    public LogClientTpSentinelShuttle shoppingtalk_id(String shoppingtalk_id){
        this.shoppingtalk_id = shoppingtalk_id;
        return this;
    }


    /*
     * Set small_category_name
     */
    public LogClientTpSentinelShuttle small_category_name(String small_category_name){
        this.small_category_name = small_category_name;
        return this;
    }


    /*
     * Set small_category_no
     */
    public LogClientTpSentinelShuttle small_category_no(Long small_category_no){
        this.small_category_no = small_category_no;
        return this;
    }


    /*
     * Set smartoption
     */
    public LogClientTpSentinelShuttle smartoption(String smartoption){
        this.smartoption = smartoption;
        return this;
    }


    /*
     * Set sohoshop_name
     */
    public LogClientTpSentinelShuttle sohoshop_name(String sohoshop_name){
        this.sohoshop_name = sohoshop_name;
        return this;
    }


    /*
     * Set sort_method
     */
    public LogClientTpSentinelShuttle sort_method(String sort_method){
        this.sort_method = sort_method;
        return this;
    }


    /*
     * Set sort_type
     */
    public LogClientTpSentinelShuttle sort_type(String sort_type){
        this.sort_type = sort_type;
        return this;
    }


    /*
     * Set specialist_name
     */
    public LogClientTpSentinelShuttle specialist_name(String specialist_name){
        this.specialist_name = specialist_name;
        return this;
    }


    /*
     * Set specialist_no
     */
    public LogClientTpSentinelShuttle specialist_no(Long specialist_no){
        this.specialist_no = specialist_no;
        return this;
    }


    /*
     * Set start_time
     */
    public LogClientTpSentinelShuttle start_time(String start_time){
        this.start_time = start_time;
        return this;
    }


    /*
     * Set stock_no
     */
    public LogClientTpSentinelShuttle stock_no(Long stock_no){
        this.stock_no = stock_no;
        return this;
    }


    /*
     * Set store_name
     */
    public LogClientTpSentinelShuttle store_name(String store_name){
        this.store_name = store_name;
        return this;
    }


    /*
     * Set tab_name
     */
    public LogClientTpSentinelShuttle tab_name(String tab_name){
        this.tab_name = tab_name;
        return this;
    }


    /*
     * Set tag_name
     */
    public LogClientTpSentinelShuttle tag_name(String tag_name){
        this.tag_name = tag_name;
        return this;
    }


    /*
     * Set to_time
     */
    public LogClientTpSentinelShuttle to_time(String to_time){
        this.to_time = to_time;
        return this;
    }


    /*
     * Set today
     */
    public LogClientTpSentinelShuttle today(String today){
        this.today = today;
        return this;
    }


    /*
     * Set trace_meta_category_no
     */
    public LogClientTpSentinelShuttle trace_meta_category_no(Long trace_meta_category_no){
        this.trace_meta_category_no = trace_meta_category_no;
        return this;
    }


    /*
     * Set trc_no
     */
    public LogClientTpSentinelShuttle trc_no(Long trc_no){
        this.trc_no = trc_no;
        return this;
    }


    /*
     * Set user_input_search_keyword
     */
    public LogClientTpSentinelShuttle user_input_search_keyword(String user_input_search_keyword){
        this.user_input_search_keyword = user_input_search_keyword;
        return this;
    }


    /*
     * Set view_type
     */
    public LogClientTpSentinelShuttle view_type(String view_type){
        this.view_type = view_type;
        return this;
    }


    /*
     * Set visible
     */
    public LogClientTpSentinelShuttle visible(String visible){
        this.visible = visible;
        return this;
    }


    /*
     * Set year_month
     */
    public LogClientTpSentinelShuttle year_month(String year_month){
        this.year_month = year_month;
        return this;
    }


    /*
     * Set search_view_type
     */
    public LogClientTpSentinelShuttle search_view_type(String search_view_type){
        this.search_view_type = search_view_type;
        return this;
    }


    /*
     * Set search_sort_type
     */
    public LogClientTpSentinelShuttle search_sort_type(String search_sort_type){
        this.search_sort_type = search_sort_type;
        return this;
    }


    /*
     * Set search_include_keyword
     */
    public LogClientTpSentinelShuttle search_include_keyword(String search_include_keyword){
        this.search_include_keyword = search_include_keyword;
        return this;
    }


    /*
     * Set search_category_no
     */
    public LogClientTpSentinelShuttle search_category_no(Long search_category_no){
        this.search_category_no = search_category_no;
        return this;
    }


    /*
     * Set search_brand_code
     */
    public LogClientTpSentinelShuttle search_brand_code(String search_brand_code){
        this.search_brand_code = search_brand_code;
        return this;
    }


    /*
     * Set search_seller_nos
     */
    public LogClientTpSentinelShuttle search_seller_nos(String search_seller_nos){
        this.search_seller_nos = search_seller_nos;
        return this;
    }


    /*
     * Set search_max_price
     */
    public LogClientTpSentinelShuttle search_max_price(Long search_max_price){
        this.search_max_price = search_max_price;
        return this;
    }


    /*
     * Set search_min_price
     */
    public LogClientTpSentinelShuttle search_min_price(Long search_min_price){
        this.search_min_price = search_min_price;
        return this;
    }


    /*
     * Set search_benefit
     */
    public LogClientTpSentinelShuttle search_benefit(String search_benefit){
        this.search_benefit = search_benefit;
        return this;
    }


    /*
     * Set search_attribute
     */
    public LogClientTpSentinelShuttle search_attribute(String search_attribute){
        this.search_attribute = search_attribute;
        return this;
    }


    /*
     * Set search_ad_show
     */
    public LogClientTpSentinelShuttle search_ad_show(String search_ad_show){
        this.search_ad_show = search_ad_show;
        return this;
    }


    /*
     * Set search_custom_yn
     */
    public LogClientTpSentinelShuttle search_custom_yn(String search_custom_yn){
        this.search_custom_yn = search_custom_yn;
        return this;
    }


    /*
     * Set search_custom_key
     */
    public LogClientTpSentinelShuttle search_custom_key(String search_custom_key){
        this.search_custom_key = search_custom_key;
        return this;
    }


    /*
     * Set search_no_result_yn
     */
    public LogClientTpSentinelShuttle search_no_result_yn(String search_no_result_yn){
        this.search_no_result_yn = search_no_result_yn;
        return this;
    }


    /*
     * Set rising_keyword
     */
    public LogClientTpSentinelShuttle rising_keyword(String rising_keyword){
        this.rising_keyword = rising_keyword;
        return this;
    }


    /*
     * Set popular_keyword
     */
    public LogClientTpSentinelShuttle popular_keyword(String popular_keyword){
        this.popular_keyword = popular_keyword;
        return this;
    }


    /*
     * Set sub_area
     */
    public LogClientTpSentinelShuttle sub_area(String sub_area){
        this.sub_area = sub_area;
        return this;
    }


    /*
     * Set cart_draw_info
     */
    public LogClientTpSentinelShuttle cart_draw_info(JSONObject cart_draw_info){
        this.cart_draw_info = cart_draw_info;
        return this;
    }


    /*
     * Set current_product_no
     */
    public LogClientTpSentinelShuttle current_product_no(Long current_product_no){
        this.current_product_no = current_product_no;
        return this;
    }


    /*
     * Set is_img_search
     */
    public LogClientTpSentinelShuttle is_img_search(String is_img_search){
        this.is_img_search = is_img_search;
        return this;
    }


    /*
     * Set disp_spce_id
     */
    public LogClientTpSentinelShuttle disp_spce_id(String disp_spce_id){
        this.disp_spce_id = disp_spce_id;
        return this;
    }


    /*
     * Set current_meta_category_no
     */
    public LogClientTpSentinelShuttle current_meta_category_no(Long current_meta_category_no){
        this.current_meta_category_no = current_meta_category_no;
        return this;
    }


    /*
     * Set current_meta_category_name
     */
    public LogClientTpSentinelShuttle current_meta_category_name(String current_meta_category_name){
        this.current_meta_category_name = current_meta_category_name;
        return this;
    }


    /*
     * Set current_large_category_no
     */
    public LogClientTpSentinelShuttle current_large_category_no(Long current_large_category_no){
        this.current_large_category_no = current_large_category_no;
        return this;
    }


    /*
     * Set current_large_category_name
     */
    public LogClientTpSentinelShuttle current_large_category_name(String current_large_category_name){
        this.current_large_category_name = current_large_category_name;
        return this;
    }


    /*
     * Set current_middle_category_no
     */
    public LogClientTpSentinelShuttle current_middle_category_no(Long current_middle_category_no){
        this.current_middle_category_no = current_middle_category_no;
        return this;
    }


    /*
     * Set current_middle_category_name
     */
    public LogClientTpSentinelShuttle current_middle_category_name(String current_middle_category_name){
        this.current_middle_category_name = current_middle_category_name;
        return this;
    }


    /*
     * Set colloseo_tag
     */
    public LogClientTpSentinelShuttle colloseo_tag(String colloseo_tag){
        this.colloseo_tag = colloseo_tag;
        return this;
    }


    /*
     * Set colloseo_method
     */
    public LogClientTpSentinelShuttle colloseo_method(String colloseo_method){
        this.colloseo_method = colloseo_method;
        return this;
    }


    /*
     * Set colloseo_channel_id
     */
    public LogClientTpSentinelShuttle colloseo_channel_id(String colloseo_channel_id){
        this.colloseo_channel_id = colloseo_channel_id;
        return this;
    }


    /*
     * Set search_cosmos_yn
     */
    public LogClientTpSentinelShuttle search_cosmos_yn(String search_cosmos_yn){
        this.search_cosmos_yn = search_cosmos_yn;
        return this;
    }


    /*
     * Set group_product_no
     */
    public LogClientTpSentinelShuttle group_product_no(Long group_product_no){
        this.group_product_no = group_product_no;
        return this;
    }


    /*
     * Set group_product_firstview_no
     */
    public LogClientTpSentinelShuttle group_product_firstview_no(Long group_product_firstview_no){
        this.group_product_firstview_no = group_product_firstview_no;
        return this;
    }


    /*
     * Set group_product_category_no
     */
    public LogClientTpSentinelShuttle group_product_category_no(Long group_product_category_no){
        this.group_product_category_no = group_product_category_no;
        return this;
    }


    /*
     * Set group_product_count
     */
    public LogClientTpSentinelShuttle group_product_count(Long group_product_count){
        this.group_product_count = group_product_count;
        return this;
    }


    /*
     * Set group_product_info
     */
    public LogClientTpSentinelShuttle group_product_info(String group_product_info){
        this.group_product_info = group_product_info;
        return this;
    }


    /*
     * Set select_filter
     */
    public LogClientTpSentinelShuttle select_filter(String select_filter){
        this.select_filter = select_filter;
        return this;
    }


    /*
     * Set buynow_draw_info
     */
    public LogClientTpSentinelShuttle buynow_draw_info(JSONObject buynow_draw_info){
        this.buynow_draw_info = buynow_draw_info;
        return this;
    }


    /*
     * Set eleven_pay_draw_info
     */
    public LogClientTpSentinelShuttle eleven_pay_draw_info(JSONObject eleven_pay_draw_info){
        this.eleven_pay_draw_info = eleven_pay_draw_info;
        return this;
    }


    /*
     * Set type_list
     */
    public LogClientTpSentinelShuttle type_list(String type_list){
        this.type_list = type_list;
        return this;
    }


    /*
     * Set qrsid
     */
    public LogClientTpSentinelShuttle qrsid(String qrsid){
        this.qrsid = qrsid;
        return this;
    }


    /*
     * Set qrquery
     */
    public LogClientTpSentinelShuttle qrquery(String qrquery){
        this.qrquery = qrquery;
        return this;
    }


    /*
     * Set search_prj
     */
    public LogClientTpSentinelShuttle search_prj(JSONObject search_prj){
        this.search_prj = search_prj;
        return this;
    }


    /*
     * Set product_no_list
     */
    public LogClientTpSentinelShuttle product_no_list(JSONObject product_no_list){
        this.product_no_list = product_no_list;
        return this;
    }


    /*
     * Set store_no
     */
    public LogClientTpSentinelShuttle store_no(Long store_no){
        this.store_no = store_no;
        return this;
    }


    /*
     * Set params
     */
    public LogClientTpSentinelShuttle params(JSONObject params){
        this.params = params;
        return this;
    }


    /*
     * Set ga_label
     */
    public LogClientTpSentinelShuttle ga_label(String ga_label){
        this.ga_label = ga_label;
        return this;
    }


    /*
     * Set utm_source
     */
    public LogClientTpSentinelShuttle utm_source(String utm_source){
        this.utm_source = utm_source;
        return this;
    }


    /*
     * Set utm_medium
     */
    public LogClientTpSentinelShuttle utm_medium(String utm_medium){
        this.utm_medium = utm_medium;
        return this;
    }


    /*
     * Set utm_campaign
     */
    public LogClientTpSentinelShuttle utm_campaign(String utm_campaign){
        this.utm_campaign = utm_campaign;
        return this;
    }


    /*
     * Set utm_content
     */
    public LogClientTpSentinelShuttle utm_content(String utm_content){
        this.utm_content = utm_content;
        return this;
    }


    /*
     * Set utm_term
     */
    public LogClientTpSentinelShuttle utm_term(String utm_term){
        this.utm_term = utm_term;
        return this;
    }





    /**
     * Layout Rules
     */
    private static final LinkedHashMap<String, ArrayList<String>> bodyRule = new LinkedHashMap<String, ArrayList<String>>(){{
    }};


    /**
     * Util Functions
     */
    private ArrayList<Field> privateHeaderMemeberList = new ArrayList<Field>();
    private ArrayList<Field> privatebodyMemeberList = new ArrayList<Field>();

    public LogClientTpSentinelShuttle() {

        Class klass = this.getClass();

        for(String name : headerFieldNameList) {
            try {
                privateHeaderMemeberList.add(klass.getDeclaredField(name));
            } catch (NoSuchFieldException e) {
                e.printStackTrace();
            }
        }

        for(String name : bodyFieldNameList) {
            try {
                privatebodyMemeberList.add(klass.getDeclaredField(name));
            } catch (NoSuchFieldException e) {
                e.printStackTrace();
            }
        }

        // init encrypt module
        initCryptoOnce();
    }

    @Override
    public String toString() {
        return toHBString();
    }

    public String toHBString() {
        return toHBString(this._$ssDelim);
    }

    public String toHBString(String delim) {
        return headerToString(delim) + bodyToString();
    }

    public String headerToString(String delim) {
        StringBuilder headerBuilder = new StringBuilder();

        for (Field member : privateHeaderMemeberList) {
            try {
                member.setAccessible(true);
                Object value = member.get(this);

                if(value == null) {
                    headerBuilder.append("");
                } else {
                    String fieldValue = String.valueOf(value);
                    if(encryptedFieldsList.contains(member.getName())) {
                        fieldValue = getEncryptedValue(fieldValue);
                    } else {
                        fieldValue = getEscapedValue(fieldValue);
                    }
                    headerBuilder.append(fieldValue);
                }

                headerBuilder.append(delim);


                member.setAccessible(false);

            } catch (IllegalAccessException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        return headerBuilder.toString();
    }


    public void clearBody(){
        for(Field bodyField:privatebodyMemeberList) {
            bodyField.setAccessible(true);
            Object value = null;
            try {
                bodyField.set(this, null);
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            }

            bodyField.setAccessible(false);
        }
        
    }


    public JSONObject getBody() {
            

            if (bodyFieldNameList.size() == 0) {
                return new JSONObject();
            }

            LinkedHashMap<String, Object> body = new LinkedHashMap<String, Object>();

            Class klass = this.getClass();

            try {
                String actionKeyString = "";
                for (String actionKeyName : this._$actionKey) {
                    Field actionKeyField = klass.getDeclaredField(actionKeyName);
                    actionKeyField.setAccessible(true);
                    Object actionKeyValue = actionKeyField.get(this);
                    actionKeyString += actionKeyValue == null ? "" : actionKeyValue.toString();
                    if(this._$actionKey.indexOf(actionKeyName) != this._$actionKey.size()-1) {
                        actionKeyString += ":";
                    }
                    actionKeyField.setAccessible(true);
                }


                ArrayList<String> thisActionLayoutRule = this.bodyRule.get(actionKeyString);

                if (thisActionLayoutRule == null) {
                    thisActionLayoutRule = new ArrayList<String>();
                }

                for (Field bodyField : this.privatebodyMemeberList) {
                    String bodyFieldName = bodyField.getName();

                    Object value = bodyField.get(this);

                    boolean isInLog = false;
                    if (value != null) {
                        if ((value instanceof String) || (value instanceof Long) || (value instanceof Double) || (value instanceof JSONObject)) {
                            isInLog = true;
                        } else if ((value instanceof List) && (((List) value).size() > 0)) {
                            isInLog = true;
                        } else if ((value instanceof Map) && (((Map) value).size() > 0)) {
                            isInLog = true;
                        }
                    }

                    if (isInLog) {
                        if (value == null) {
                            body.put(bodyFieldName, "");
                        } else {
                            if (value instanceof List) {
                                body.put(bodyFieldName, new JSONArray((List) value));
                            } else if (value instanceof Map) {
                                body.put(bodyFieldName, new JSONObject((Map) value));
                            } else {
                                if (encryptedFieldsList.contains(bodyFieldName)) {
                                    body.put(bodyFieldName, getEncryptedValue(String.valueOf(value)));
                                } else {
                                    if(value instanceof String) {
                                        body.put(bodyFieldName, getEscapedValue((String)value));
                                    } else {
                                        body.put(bodyFieldName, value);
                                    }
                                }
                            }
                        }
                    }
                }

                JSONObject bodyJSONOjbect = new JSONObject(body);

                return bodyJSONOjbect;
            } catch (NoSuchFieldException e) {
                e.printStackTrace();
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }

            return null;
        }


    public String bodyToString() {
        
        if(bodyFieldNameList.size() == 0) {
            return "{}";
        }
        return getEscapedValue(this.getBody().toString());
    }


    public static JSONObject getSentinelMeta() {
        JSONObject sentinel_meta = new JSONObject();
        JSONObject container = new JSONObject();

        try {
            sentinel_meta.put("_$schemaId", _$ssSchemaId);

            JSONObject fieldOrder = new JSONObject();
            int i = 0;
            for(i = 0; i < headerFieldNameList.size(); i++) {
                fieldOrder.put(headerFieldNameList.get(i), i);
            }

            fieldOrder.put("_$body",i);
            sentinel_meta.put("_$fieldOrder", fieldOrder);

            sentinel_meta.put("_$encryptionFields", new JSONArray(encryptedFieldsList));
            sentinel_meta.put("_$projectId", _$projectId);

            container.put("sentinel_meta", sentinel_meta);
        } catch (JSONException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }

        return container;
    }


    public static JSONObject toJSONObject(JSONObject jsonObject) {
        JSONObject container = new JSONObject();
        JSONObject body = new JSONObject();

        try {
            for(String name : headerFieldNameList) {
                if(jsonObject.has(name)) {
                    container.put(name, jsonObject.get(name));
                } else{
                    container.put(name,"");
                }
            }

            container.put(_$logVersionKey, _$ssVersion);

            for(String name : bodyFieldNameList) {
                if(jsonObject.has(name)) {
                    body.put(name, jsonObject.get(name));
                }
            }

            container.put("_$body", body);
            container.put("sentinel_meta", getSentinelMeta().get("sentinel_meta"));

        } catch (JSONException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }

        return container;
    }


    public JSONObject toJSONObject() {
        JSONObject jsonObj = new JSONObject();

        try {
            for (Field member : privateHeaderMemeberList) {
                member.setAccessible(true);
                String key = member.getName();
                Object value = member.get(this);


                if(value != null) {
                    if(encryptedFieldsList.contains(member.getName())) {
                        jsonObj.put(key, getEncryptedValue(String.valueOf(value)));
                    } else {
                        if(value instanceof String) {
                            jsonObj.put(key, getEscapedValue((String)value));
                        } else {
                            jsonObj.put(key, value);
                        }
                    }
                } else {
                    jsonObj.put(key, "");
                }

                member.setAccessible(false);
            }

            jsonObj.put("_$body", this.getBody());
            jsonObj.put("sentinel_meta", getSentinelMeta().get("sentinel_meta"));

        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (JSONException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }

        return jsonObj;
    }

    public String toJSONString() {
        return this.toJSONObject().toString();
    }

    public String getEscapedValue(String value){
        String vt = Character.toString((char) 0x0b);
        String escapedVt = "\\"+"0x0b";
        String escaped = value.replaceAll(vt, escapedVt).replaceAll("\n","\\\\n").replaceAll("\t","\\\\t").replaceAll("\r","\\\\r");
        return escaped;
    }

    
    private void initCrypto(){
        // Do nothing
    }

    private void initCryptoOnce(){
        // Do nothing
    }

    private String getEncryptedValue(String value){
        return value;
    }

    public void setPublicKey(String modulus_n, String pub_exponent) {
        // Do nothing
    }

    
}
